import org.apache.tools.ant.filters.*;
import java.io.*;
import org.apache.tools.ant.types.*;

public class Filter extends BaseParamFilterReader implements ChainableReader {

	InputStream pre = null;
	InputStream app = null;

	public Filter() { super(); }
	public Filter(Reader in) { super(in); }

	public final java.io.Reader chain(java.io.Reader rdr) {
		Filter f = new Filter(rdr);
		return f;
	}
	public void setAppend(String file) {
		try {
			app = new FileInputStream(file);
		} catch (IOException ioe) {
			app = new ByteArrayInputStream(("[Error occured: "+ioe+"]").getBytes());
			ioe.printStackTrace();
		}
	}
	public void setPrepend(String file) {
		try {
			pre = new FileInputStream(file);
		} catch (IOException ioe) {
			pre = new ByteArrayInputStream(("[Error occured: "+ioe+"]").getBytes());
			ioe.printStackTrace();
		}
	}
	public int read() throws IOException {
		Parameter[] p = getParameters();
		for (int i=0; i<p.length; i++) {
			if (app==null && p[i].getName().equals("append")) setAppend(p[i].getValue());
			if (pre==null && p[i].getName().equals("prepend")) setPrepend(p[i].getValue());
		}
		int result = -1;
		if (              pre!=null) result = pre.read();
		if (result==-1             ) result = super.read();
		if (result==-1 && app!=null) result = app.read();
		return result;
	}
}
