package cebit;

import java.io.*;
import java.util.*;

/** Kopiert AppelRuleSet-Eintrge der Datenbank in ein File oder aus einem solchen
 * in die Datenbank. Start ber Kommandozeile.
 * @author Thomas Kriegelstein
 * @version $Id: Config.java,v 1.6 2004/01/27 15:41:51 tk4 Exp $
 */
public class AppelRules {
	/** berprft die Parameter, wertet sie aus, erledigt die Arbeit.
	 * @param args Parameterliste
	 * @throws Exception Im Fehlerfall
	 */
	public static void main(String[] args) throws Exception {
		// Parameter
		int command = -1;
		String file = null;
		String id = null;
		String configname = "cfg/dbi.properties";

		/////////////////////////////////////////////////////////
		// Kommandozeile auswerten
		for (int i = 0; i < args.length; i++) {
			if ("-help".equals(args[i])) {
				System.out.print(
					""
						+ "AppelRules [option] command id file                            \n"
						+ "option is one of:                                              \n"
						+ "  -help           display this list and exit                   \n"
						+ "  -cfg filename   use configfile instead of cfg/dbi.properties \n"
						+ "command is one of:                                             \n"
						+ "  import          import into database                         \n"
						+ "  export          export from database                         \n"
						+ "id                is the identifier                            \n"
						+ "file              is the filename                              \n"
						+ "");
				System.exit(0);
			} else if ("-cfg".equals(args[i])) {
				if (i + 1 >= args.length) {
					System.out.println("Filename missing.");
				} else {
					configname = args[++i];
				}
			} else if (i + 3 <= args.length) {
				if ("import".equals(args[i])) {
					command = 0;
				} else if ("export".equals(args[i])) {
					command = 1;
				} else {
					System.out.println(
						"Command: " + args[i] + " unrecognized.");
					args[i--] = "-help";
					continue;
				}
				i++;
				id = args[i];
				i++;
				file = args[i];
				if (command == 0 && !(new File(file)).exists()) {
					System.out.println(
						"Could not import: " + file + " File does not exist.");
					args[i--] = "-help";
					continue;
				}
			} else {
				System.out.println("Option: " + args[i] + " unrecognized.");
				args[i--] = "-help";
				continue;
			}
		}
		if (!(new File(configname)).exists()) {
			System.out.println("Configfile: " + configname + " not found.");
			System.exit(1);
		}

		/////////////////////////////////////////////////////////
		// Datenbankverbindung herstellen und Arbeit verrichten

		Properties settings = new Properties();
		settings.load(new FileInputStream(configname));
		convert(settings);
		idman.AppelRules.doit(settings, command, id, file);
	}
	private static void convert(Properties p) {
		for (Enumeration e = p.propertyNames(); e.hasMoreElements();) {
			String name = (String)e.nextElement();
			if (name.startsWith("dbi.")) {
				String val = p.getProperty(name);
				p.setProperty(name, val);
			} else if (name.startsWith("cebit.proxy.idm.")) {
				String val = p.getProperty(name);
				p.setProperty(name.substring(16), val);
			} else if (name.startsWith("cebit.server.idm.")) {
				String val = p.getProperty(name);
				p.setProperty(name.substring(17), val);
			}
		}
	}
}
