/**
 * @version working
 * @author Thomas Kriegelstein
 * $Id: Editor.java,v 1.17 2004/06/16 10:13:07 tk4 Exp $
 */
package cebit.proxy.gui;

import java.awt.*;

import javax.swing.filechooser.*;
import javax.swing.*;
import java.awt.image.*;

import java.io.File;

/**
 * Container fr Visitenkarte und Pseudonymregeln.
 * <br><b>Hinweis:</b> Oberflche wurde mit NetBeans/Forte erstellt.
 * @author Thomas Kriegelstein
 * @version $Id: Editor.java,v 1.17 2004/06/16 10:13:07 tk4 Exp $
 */
public class Editor extends javax.swing.JPanel {
    public static boolean debug = false;
    
    /** VisitenKarte als P3P Regeldarsteller und Datenformular. */
    protected VisitenKarte vk = null;
    /** Regelset fuer Pseudonymverwendung. */
    protected String[][] ruleset = null;
    /** Liefert die Pseudonymregeln. */
    public String[][] getRules() { return ruleset; }
    /** The icon of the role */
    protected BufferedImage roleImage;
    /** The Image for the roleIcon */
    protected javax.swing.ImageIcon roleIcon;
    /** returns the icon */
    public BufferedImage getRoleIcon() { return roleImage; }
    
    /** Current Directory for file selection */
    private File currentDir = new File(System.getProperty("user.dir"),"roleicons");
    
    /** Creates new form Editor.
     * @param vk Visiting Card to embed
     * @param ruleset former rules
     * @param roleImage image to change/display
     * @param roleName name to change/display
     * @param respectRoles whether to use role based rules or not
     */
    public Editor(VisitenKarte vk, String[][] ruleset, BufferedImage roleImage, String roleName, boolean respectRoles) {
        this.roleImage = roleImage;
        if(roleImage == null){
            roleImage = new BufferedImage(64,64,BufferedImage.TYPE_INT_RGB);
        }
        if(roleIcon == null){
            roleIcon= new javax.swing.ImageIcon(roleImage);
        }
        initComponents();
        jPanel2.add(vk);
        int c = determine(ruleset);
        this.ruleset = ruleset;
        eachButton.setEnabled(respectRoles);
        allButton.setEnabled(respectRoles);
        neverButton.setEnabled(respectRoles);
        switch (c) {
            case 0: neverButton.setSelected(true); break;
            case 3: eachButton.setSelected(true); break;
            case 4: allButton.setSelected(true); break;
        }
        nameField.setText(roleName);
        roleIconButton.setIcon(roleIcon);
        nameField.setEditable(false);
        
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        nameField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        eachButton = new javax.swing.JRadioButton();
        allButton = new javax.swing.JRadioButton();
        neverButton = new javax.swing.JRadioButton();
        roleIconChangeButton1 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        roleIconButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Name_der_Rolle"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel1.add(jLabel1, gridBagConstraints);

        nameField.setText("jTextField1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 10.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel1.add(nameField, gridBagConstraints);

        jLabel3.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("rolename_privacy_desription"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        jPanel1.add(jLabel3, gridBagConstraints);

        jLabel2.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Your_actions_and_data_can_be_linked_for_this_role"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(25, 5, 5, 5);
        jPanel1.add(jLabel2, gridBagConstraints);

        buttonGroup1.add(eachButton);
        eachButton.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("by_each_website_separately"));
        eachButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                eachButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 35, 5, 5);
        jPanel1.add(eachButton, gridBagConstraints);

        buttonGroup1.add(allButton);
        allButton.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("by_all_websites"));
        allButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                allButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 35, 5, 5);
        jPanel1.add(allButton, gridBagConstraints);

        buttonGroup1.add(neverButton);
        neverButton.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("never"));
        neverButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                neverButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 35, 5, 5);
        jPanel1.add(neverButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 10.0;
        add(jPanel1, gridBagConstraints);

        roleIconChangeButton1.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("SELECT_ROLE_ICON"));
        roleIconChangeButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                roleIconChangeButton1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        add(roleIconChangeButton1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.BorderLayout());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 10.0;
        gridBagConstraints.weighty = 10.0;
        add(jPanel2, gridBagConstraints);

        roleIconButton.setMinimumSize(new java.awt.Dimension(60, 60));
        roleIconButton.setPreferredSize(new java.awt.Dimension(60, 60));
        roleIconButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                roleIconButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(roleIconButton, gridBagConstraints);

    }//GEN-END:initComponents

    private void roleIconButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_roleIconButtonActionPerformed
        // Add your handling code here:
        this.roleIconChangeButton1ActionPerformed(evt);
    }//GEN-LAST:event_roleIconButtonActionPerformed
    
    private void neverButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_neverButtonItemStateChanged
        // Add your handling code here:
        selectRules();
    }//GEN-LAST:event_neverButtonItemStateChanged
    
    private void allButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_allButtonItemStateChanged
        // Add your handling code here:
        selectRules();
    }//GEN-LAST:event_allButtonItemStateChanged
    
    private void eachButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_eachButtonItemStateChanged
        // Add your handling code here:
        selectRules();
    }//GEN-LAST:event_eachButtonItemStateChanged
    
    private void roleIconChangeButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_roleIconChangeButton1ActionPerformed
        // Add your handling code here:
        javax.swing.JFileChooser jfc = new javax.swing.JFileChooser();
        
        jfc.addChoosableFileFilter(new FileFilter(){
            //Accept directories and .gif, .jpg, .tiff, .png files
            public boolean accept(File file) {
                if (file.isDirectory()) {
                    return true;
                }
                String fn = file.getName();
                fn = fn.toLowerCase();
                if (fn.endsWith(".gif") ||
                fn.endsWith(".jpeg") ||
                fn.endsWith(".jpg") ||
                fn.endsWith(".png")){
                    return true;
                } else {
                    return false;
                }
            }
            
            //filter description
            public String getDescription() {
                return java.util.ResourceBundle.getBundle("cebit/proxy/gui/language")
                .getString("IMAGE_FILES")+" (.gif,.jpeg,.jpg,.png)";
            }
        });
        jfc.setAcceptAllFileFilterUsed(false);
        jfc.setDialogTitle(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language")
        .getString("SELECT_ROLE_ICON"));
        jfc.setDialogType(javax.swing.JFileChooser.CUSTOM_DIALOG);
        jfc.setMultiSelectionEnabled(false);
        jfc.setCurrentDirectory(currentDir);
        //Add preview panel
        jfc.setAccessory(new ImagePreview(jfc));
        
        //Show image chooser
        if (debug) System.err.println(jfc.getCurrentDirectory());
        int ret = jfc.showDialog(this, java.util.ResourceBundle.getBundle("cebit/proxy/gui/language")
        .getString("SELECT"));
        
        if (ret == javax.swing.JFileChooser.APPROVE_OPTION) {
            if(debug) System.out.println("Icon selection: Approve Button pressed");
            File file = jfc.getSelectedFile();
            boolean imageOK = false;
            if(file != null){
                BufferedImage tmpImage;
                try{
                    tmpImage = javax.imageio.ImageIO.read(file);
                }catch(java.io.IOException ioe){
                    tmpImage = null;
                }
                if (tmpImage != null) {
                    if ((tmpImage.getWidth() != 64) || (tmpImage.getHeight() != 64)) {
                        BufferedImage bimage2
                        = new BufferedImage(64,64, BufferedImage.TYPE_INT_RGB);
                        Graphics2D g2d = (Graphics2D) bimage2.getGraphics();
                        g2d.scale((double) 64 / tmpImage.getWidth(), (double) 64 / tmpImage.getHeight());
                        g2d.drawImage(tmpImage, 0, 0, new javax.swing.JFrame());
                        g2d.dispose();
                        tmpImage = bimage2;
                    }
                    roleImage = tmpImage;
                    
                    roleIcon = new ImageIcon(roleImage);
                    roleIconButton.setIcon(roleIcon);
                    roleIconButton.invalidate();
                    roleIconButton.repaint();
                    imageOK = true;
                }
            }
            if(!imageOK){
                javax.swing.JOptionPane.showMessageDialog(this,
                java.util.ResourceBundle.getBundle("cebit/proxy/gui/language")
                .getString("ERROR"),
                java.util.ResourceBundle.getBundle("cebit/proxy/gui/language")
                .getString("ERROR_READING_ICON"),
                javax.swing.JOptionPane.ERROR_MESSAGE);
            }
        }
        currentDir = jfc.getCurrentDirectory();
    }//GEN-LAST:event_roleIconChangeButton1ActionPerformed
    
    /**
     * Calls the dialog to choose a new icon, and  changes the icon accordingly.
     * @param evt not used
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton allButton;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JRadioButton eachButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField nameField;
    private javax.swing.JRadioButton neverButton;
    private javax.swing.JButton roleIconButton;
    private javax.swing.JButton roleIconChangeButton1;
    // End of variables declaration//GEN-END:variables
    
    public String getRoleName() {
        return nameField.getText();
    }
    
    /** Vorgegebene Pseudonymtypen. */
    protected String[] actions = {"idman.rules.PseudonymProvider.getTransactionPseudonym", "idman.rules.PseudonymProvider.getRelationPseudonym", "idman.rules.PseudonymProvider.getPersonalPseudonym", "idman.rules.PseudonymProvider.getRoleRelationPseudonym", "idman.rules.PseudonymProvider.getRolePseudonym"};
    private void selectRules() {
        String[][] newRules = new String[ruleset.length][];
        for (int i=0; i<newRules.length; i++) {
            newRules[i]=new String[ruleset[i].length];
            System.arraycopy(ruleset[i], 0, newRules[i], 0, newRules.length);
        }
        // DEPENDEND
        if (eachButton.isEnabled() && eachButton.isSelected()) {
            newRules[0][2]=actions[3];
        } else if (allButton.isEnabled() && allButton.isSelected()) {
            newRules[0][2]=actions[4];
        } else if (neverButton.isEnabled() && neverButton.isSelected()) {
            newRules[0][2]=actions[0];
        }
        ruleset = newRules;
    }
    
    // bestimmt zu einem Regelsatz dessen Einstellung der Combobox, indem er den Regelsatz erst mit einer allgemeinen Form vergleicht und anschliessend die genaue auswahl bestimmt
    private int determine(String[][] ruleset) {
        String[][] blueprint = {
            {null, "idman.rules.AllwaysTrue", null, null},
            {null, "idman.rules.ValidPseudonym", "ACCEPT", null},
            {null, "idman.rules.AllwaysTrue", null, null}
        };
        if (ruleset.length!=blueprint.length)
            return -1;
        for (int i=0; i<ruleset.length; i++) {
            for (int j=0; j<ruleset[i].length; j++) {
                if (blueprint[i][j]!=null && !blueprint[i][j].equals(ruleset[i][j]))
                    return -1;
            }
        }
        for (int i=0; i<actions.length; i++) {
            if (actions[i].equals(ruleset[0][2]))
                return i;
            else
                ;//System.out.println("Won't match: >"+actions[i]+"< != >"+ruleset[0][2]+"<");
        }
        return -1;
    }
    
    /**
     * Testmethode. Nicht staendig aktualisiert.
     */
    public static void main(String[] args) {
        String[][] ruleset = {
            {"Dummy", "idman.rules.AllwaysTrue", "idman.rules.PseudonymProvider.getTransactionPseudonym", "N/A"},
            {"Dummy", "idman.rules.ValidPseudonym", "ACCEPT", "N/A"},
            {"Dummy", "idman.rules.AllwaysTrue", "REJECT", "N/A"}
        };
        VisitenKarte vk = new VisitenKarte();
        try{
            Editor e = new Editor(vk, ruleset,
            javax.imageio.ImageIO.read(vk.getClass().getResource("/proxy/Anonym.png")), "main(String[] args)", false);
            javax.swing.JOptionPane.showConfirmDialog(null, e, "main(String[] args)", javax.swing.JOptionPane.OK_CANCEL_OPTION);
        }catch(java.io.IOException ioe){
            ioe.printStackTrace();
        }
        System.exit(0);
    }
}
