package cebit.proxy.gui;

public class Profiler {

	public static boolean debug = true;

	public static boolean createProfile(
		String mozilla,
		String dir,
		String name)
		throws java.io.IOException {

		Runtime r = Runtime.getRuntime();
		Process p = null;
		String role = name;
		name = role.replace(' ','_');
		try {
			p = r.exec(new String[] { mozilla, "-CreateProfile", name });
			p.waitFor();
		} catch (Exception e) {
			if (debug)
				e.printStackTrace();
			return false;
		}

		java.io.File f1 = null;
		f1 = new java.io.File(dir + "/.mozilla/" + name + "/."); // Un*x/L*nux?
		if (!f1.exists())
			f1 = new java.io.File(dir + "/.phoenix/" + name + "/.");
		if (!f1.exists())
			f1 =
				new java.io.File(
					dir + "/Library/Mozilla/Profiles/" + name + "/."); // Mac
		if (!f1.exists())
			f1 =
				new java.io.File(
					dir + "/Library/Phoenix/Profiles/" + name + "/.");
		// for windows only... do the search dance here
		if (!f1.exists()) {
			java.io.File where = new java.io.File(dir);
			java.io.File[] files = where.listFiles();
			for (int i = 0; i < files.length; i++) {
				if ((f1 =
					new java.io.File(
						files[i],
						"/Mozilla/Profiles/" + name + "/."))
					.exists()) {
					break;
				}
				if ((f1 =
					new java.io.File(
						files[i],
						"/Phoenix/Profiles/" + name + "/."))
					.exists()) {
					break;
				}
			}
		}
		if (!f1.exists())
			f1 = new java.io.File(dir + "/Mozilla/Profiles/" + name + "/.");
		if (!f1.exists()) {
			if (debug)
				System.out.println(
					"Profiler Error: " + f1.getPath() + " does not exist.");
			return false;
		}
		java.io.File[] fa = f1.listFiles();
		if (fa.length != 1) {
			if (debug)
				System.out.println(
					"Profiler Error: "
						+ f1.getPath()
						+ " does not contain files.");
			return false;
		}
		java.io.File f3 = fa[0];
		if (!f3.exists()) {
			if (debug)
				System.out.println(
					"Profiler Error: " + f3.getPath() + " does not exist.");
			return false;
		}
		java.io.File f4 = new java.io.File(f3, "prefs.js");
		if (!f4.exists()) {
			if (debug)
				System.out.println(
					"Profiler Error: " + f4.getPath() + " does not exist.");
			return false;
		}
		java.io.File f5 = new java.io.File(f3, "prefs.new");
		if (f5.exists()) {
			if (debug)
				System.out.println(
					"Profiler Error: " + f5.getPath() + " does exist.");
			return false;
		}
		java.io.File f6 = new java.io.File(f3, "generated.s");
		if (f6.exists())
			return true; // old one, reuse it

		java.io.File f7 = new java.io.File(f3, "panels.rdf");
		if (!f7.exists()) {
			if (debug)
				System.out.println(
					"Profiler Error: " + f7.getPath() + " does not exist.");
			return false;
		}
		java.io.File f8 = new java.io.File(f3, "panels.new");
		if (f8.exists()) {
			if (debug)
				System.out.println(
					"Profiler Error: " + f1.getPath() + " does exist.");
			return false;
		}

		java.io.InputStream is1 = new java.io.FileInputStream(f4);
		java.io.OutputStream os1 = new java.io.FileOutputStream(f5);
		for (int i = 0; -1 != (i = is1.read());)
			os1.write(i);
		is1.close();
		os1.write(
			"user_pref(\"network.proxy.http\", \"localhost\");\n".getBytes());
		os1.write("user_pref(\"network.proxy.http_port\", 8004);\n".getBytes());
		os1.write(
			"user_pref(\"network.proxy.no_proxies_on\", \"\");\n".getBytes());
		os1.write("user_pref(\"network.proxy.type\", 1);\n".getBytes());
		os1.write(
			"user_pref(\"signon.SignonFileName\", \"generated.s\");\n"
				.getBytes());
		os1.write("user_pref(\"wallet.caveat\", true);\n".getBytes());
		os1.close();
		f4.delete();
		f5.renameTo(f4);

		java.io.OutputStream os2 = new java.io.FileOutputStream(f6);
		os2.write("#2c\n".getBytes());
		os2.write(".\n".getBytes());
		os2.write("localhost:8004 (Proxy)\n".getBytes());
		os2.write("\\=username=\\\n".getBytes());
		os2.write(
			("~" + new sun.misc.BASE64Encoder().encodeBuffer(role.getBytes()))
				.getBytes());
		os2.write("*\\=password=\\\n".getBytes());
		os2.write(
			("~" + new sun.misc.BASE64Encoder().encodeBuffer(role.getBytes()))
				.getBytes());
		os2.write(".\n".getBytes());
		os2.close();

		java.io.InputStream is2 = new java.io.FileInputStream(f7);
		java.io.DataInput is3 = new java.io.DataInputStream(is2);
		java.io.OutputStream os3 = new java.io.FileOutputStream(f8);
		String[] ins =
			{
				"<RDF:li resource=\"urn:sidebar:panel:history\"/>",
				"</RDF:RDF>" };
		String[][] ous =
			{
				{
					"<RDF:li resource=\"urn:sidebar:panel:history\"/>",
					"<RDF:li resource=\"urn:sidebar:panel:role\"/>" },
				{
				"  <RDF:Description about=\"urn:sidebar:panel:role\">",
					"    <NC:title>Rolle</NC:title>",
					"    <NC:content>http://localhost:8004/role</NC:content>",
					"  </RDF:Description>",
					"</RDF:RDF>" }
		};
		for (;;) {
			String line = is3.readLine();
			if (line == null)
				break; // End of File
			boolean found = false;
			for (int i = 0; i < ins.length; i++) {
				int idx = line.indexOf(ins[i]);
				if (idx >= 0) {
					line = line.substring(0, idx);
					for (int j = 0; j < ous[i].length; j++)
						os3.write((line + ous[i][j] + "\n").getBytes());
					found = true;
					break;
				}
			}
			if (!found) {
				line += "\n";
				os3.write(line.getBytes());
			}
		}
		is2.close();
		os3.close();
		f7.delete();
		f8.renameTo(f7);
		return true;
	}
}