/**
 * @version working
 * @author Thomas Kriegelstein
 * @author Sebastian Clau
 * $Id: Starter.java,v 1.35 2004/06/16 13:21:26 tk4 Exp $
 */
package cebit.proxy.gui;

import idman.dbi.Database;
import idman.mngt.Context;
import idman.mngt.Management;
import idman.mngt.impl.P3PListener;

import java.awt.image.BufferedImage;
import java.io.*;
import java.net.URI;
import java.util.*;

import javax.swing.JOptionPane;
import javax.swing.UIManager;

import psman.data.*;
import psman.dbi.DBI;
import cebit.Reinit;
import cebit.proxy.Proxy;

/**
 * GUI fr Demonstrator.
 *
 * @author Thomas Kriegelstein
 * @author Sebastian Clau
 * @version $Id: Starter.java,v 1.35 2004/06/16 13:21:26 tk4 Exp $
 */
public class Starter extends javax.swing.JPanel {

	public final static String xmlns = "http://www.w3.org/2000/xmlns/";
	public static final String p3p = "http://www.w3.org/2002/01/P3Pv1";
	public final static String appel = "http://www.w3.org/2001/02/APPELv1";
	public static boolean debug = false;
	public static boolean askUser = false;
	static String mozilla = null;

	/** Creates new form DynamicStarter */
	public Starter() {
		initComponents();
		initLookAndFeelMenu();
		initMozillaMenuItem();
		initLocaleSettings();
		jCheckBoxMenuItem1.setSelected(false);
	}

	/** Fr XML-Verarbeitung. */
	static javax.xml.parsers.DocumentBuilderFactory dbf = null;
	/** Fr XML-Verarbeitung. */
	static javax.xml.parsers.DocumentBuilder db = null;
	/** Fr XML-Verarbeitung. */
	static javax.xml.transform.TransformerFactory tf = null;
	/** Fr XML-Verarbeitung. */
	static javax.xml.transform.Transformer t = null;
	/** Initialisiert XML-Verarbeitung. */
	static {
		//idman.rules.DefaultCertificateListener.debug=true;
		//idman.rules.ChainEvaluator.debug=true;
		try {
			dbf = javax.xml.parsers.DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			db = dbf.newDocumentBuilder();
			tf = javax.xml.transform.TransformerFactory.newInstance();
			t = tf.newTransformer();
			t.setOutputProperty(javax.xml.transform.OutputKeys.INDENT, "yes");
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	/**
	 * Contains all Browser processes running.
	 */
	Hashtable browserProcesses = new Hashtable();

	/**
	 * Listener fr P3P.
	 */
	P3PListener listener = null;

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	private void initComponents() { //GEN-BEGIN:initComponents
		java.awt.GridBagConstraints gridBagConstraints;

		jPopupMenu1 = new javax.swing.JPopupMenu();
		jMenuItem1 = new javax.swing.JMenuItem();
		jMenuBar1 = new javax.swing.JMenuBar();
		jMenu1 = new javax.swing.JMenu();
		jMenuItem2 = new javax.swing.JMenuItem();
		jMenu2 = new javax.swing.JMenu();
		jMenu3 = new javax.swing.JMenu();
		jMenuItem3 = new javax.swing.JMenuItem();
		jMenuItem4 = new javax.swing.JMenuItem();
		jMenuItem6 = new javax.swing.JMenuItem();
		jCheckBoxMenuItem1 = new javax.swing.JCheckBoxMenuItem();
		jMenu4 = new javax.swing.JMenu();
		jMenuItem5 = new javax.swing.JMenuItem();
		buttonGroup1 = new javax.swing.ButtonGroup();
		jPanel1 = new javax.swing.JPanel();
		jButton1 = new javax.swing.JButton();
		jPanel2 = new javax.swing.JPanel();
		jCheckBox1 = new javax.swing.JCheckBox();
		jLabel1 = new javax.swing.JLabel();
		jRadioButton1 = new javax.swing.JRadioButton();
		jRadioButton2 = new javax.swing.JRadioButton();
		jRadioButton3 = new javax.swing.JRadioButton();
		jPanel3 = new javax.swing.JPanel();
		jLabel2 = new javax.swing.JLabel();
		jLabel3 = new javax.swing.JLabel();
		scrollPanel = new javax.swing.JScrollPane();
		rolePanel = new javax.swing.JPanel();

		jPopupMenu1.setName("killBrowser");
		jMenuItem1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"CLOSE_BROWSER_FOR_THIS_ROLE"));
		jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem1ActionPerformed(evt);
			}
		});

		jPopupMenu1.add(jMenuItem1);

		jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem2ActionPerformed(evt);
			}
		});

		jMenu1.add(jMenuItem2);

		jMenuBar1.add(jMenu1);

		jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem3ActionPerformed(evt);
			}
		});

		jMenu3.add(jMenuItem3);

		jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem4ActionPerformed(evt);
			}
		});

		jMenu3.add(jMenuItem4);

		jMenu2.add(jMenu3);

		jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem6ActionPerformed(evt);
			}
		});

		jMenu2.add(jMenuItem6);

		jCheckBoxMenuItem1.setSelected(true);
		jCheckBoxMenuItem1.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent evt) {
				jCheckBoxMenuItem1ItemStateChanged(evt);
			}
		});

		jMenu2.add(jCheckBoxMenuItem1);

		jMenuBar1.add(jMenu2);

		jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem5ActionPerformed(evt);
			}
		});

		jMenu4.add(jMenuItem5);

		jMenuBar1.add(jMenu4);

		setLayout(new java.awt.GridBagLayout());

		jButton1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"NEUE_ROLLE_ANLEGEN"));
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jPanel1.add(jButton1);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		add(jPanel1, gridBagConstraints);

		jPanel2.setLayout(new java.awt.GridBagLayout());

		jPanel2.setBorder(new javax.swing.border.EtchedBorder());
		jCheckBox1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Disable_role_related_linkability_use_instead"));
		jCheckBox1.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent evt) {
				jCheckBox1ItemStateChanged(evt);
			}
		});

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
		jPanel2.add(jCheckBox1, gridBagConstraints);

		jLabel1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Your_actions_and_data_can_be_linked"));
		jLabel1.setEnabled(false);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(0, 22, 4, 0);
		jPanel2.add(jLabel1, gridBagConstraints);

		jRadioButton1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"by_each_website_separately"));
		buttonGroup1.add(jRadioButton1);
		jRadioButton1.setEnabled(false);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(0, 22, 0, 0);
		jPanel2.add(jRadioButton1, gridBagConstraints);

		jRadioButton2.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"by_all_websites"));
		buttonGroup1.add(jRadioButton2);
		jRadioButton2.setEnabled(false);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 3;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new java.awt.Insets(0, 22, 0, 0);
		jPanel2.add(jRadioButton2, gridBagConstraints);

		jRadioButton3.setSelected(true);
		jRadioButton3.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"never"));
		buttonGroup1.add(jRadioButton3);
		jRadioButton3.setEnabled(false);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 4;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(0, 22, 0, 0);
		jPanel2.add(jRadioButton3, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.weightx = 1.0;
		add(jPanel2, gridBagConstraints);

		jPanel3.setLayout(new java.awt.GridBagLayout());

		jPanel3.setBorder(new javax.swing.border.EtchedBorder());
		jLabel2.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Rollen"));
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
		jPanel3.add(jLabel2, gridBagConstraints);

		jLabel3.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SETTINGS"));
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 10);
		jPanel3.add(jLabel3, gridBagConstraints);

		scrollPanel.setMinimumSize(new java.awt.Dimension(22, 100));
		scrollPanel.setPreferredSize(new java.awt.Dimension(100, 100));
		rolePanel.setLayout(new java.awt.GridBagLayout());

		scrollPanel.setViewportView(rolePanel);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridwidth = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 2.0;
		jPanel3.add(scrollPanel, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 2.0;
		add(jPanel3, gridBagConstraints);

	} //GEN-END:initComponents

	private void jCheckBox1ItemStateChanged(java.awt.event.ItemEvent evt) {
		//GEN-FIRST:event_jCheckBox1ItemStateChanged
		// actions to do if the checkbox for disabling role based linkability is checked/unchecked
		boolean toggle =
			(evt.getStateChange() == java.awt.event.ItemEvent.SELECTED);
		jLabel1.setEnabled(toggle);
		jRadioButton1.setEnabled(toggle);
		jRadioButton2.setEnabled(toggle);
		jRadioButton3.setEnabled(toggle);
		if (toggle) {
			// TODO: 
			// Toggles anhand konfiguration setzen
		}
	} //GEN-LAST:event_jCheckBox1ItemStateChanged

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jButton1ActionPerformed
		try {
			psman.data.Role role = null;
			java.util.Properties settings = Proxy.idManager.settings;
			final psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			psman.data.Role[] roles = dbi.selectRole();
			while (role == null) {
				String name =
					javax.swing.JOptionPane.showInputDialog(
						getParent().getParent().getParent().getParent(),
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"NEW_ROLE_NAME_LABEL"),
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"NEW_ROLE_TITLE"),
						javax.swing.JOptionPane.QUESTION_MESSAGE);
				if (name == null)
					break;
				if (name.length() == 0)
					continue;
				if (!Profiler
					.createProfile(
						mozilla,
						System.getProperty("user.home"),
						name)) {
					javax.swing.JOptionPane.showMessageDialog(
						getParent().getParent().getParent().getParent(),
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"MOZILLA_PROFILE_CREATION_ERROR_1")
							+ " \""
							+ name
							+ "\" "
							+ java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"MOZILLA_PROFILE_CREATION_ERROR_2")
							+ "\n\n"
							+ java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"MOZILLA_PROFILE_CREATION_ERROR_3")
							+ " \""
							+ name
							+ "\" "
							+ java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"MOZILLA_PROFILE_CREATION_ERROR_4"),
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"MOZILLA_PROFILE_CREATION_ERROR_TITLE"),
						javax.swing.JOptionPane.ERROR_MESSAGE);
					break;
				}
				role = dbi.selectRole(name);
				if (role == null) {
					role = new psman.data.Role(name);
					dbi.insert(role);
					fixRules(name, dbi);
					roles = dbi.selectRole();
				} else {
					role = null;
				}
			}
			if (role != null) {
				this.setRoles(roles);
				rolePanel.repaint();
				this.editSettings(role.getName(), false);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	} //GEN-LAST:event_jButton1ActionPerformed

	private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jMenuItem1ActionPerformed
		// Add your handling code here:
	} //GEN-LAST:event_jMenuItem1ActionPerformed

	/**
	 * Initializes the Look and Feel menu. Adds all Look and Feels available.
	 */
	private void initLookAndFeelMenu() {
		jMenuLaf = new javax.swing.JMenu();
		jMenuLaf.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"LOOK_AND_FEEL"));

		UIManager.LookAndFeelInfo[] lafI = UIManager.getInstalledLookAndFeels();
		// remove duplicate LaF-Entries (in case a laf is registered in the
		// system, but also (aditionally) by the appliction.
		HashSet lafNames = new HashSet();
		if (lafI.length > 1) {
			for (int i = 0; i < lafI.length; i++) {
				if (!lafNames.contains(lafI[i].getName())) {
					try {
						javax.swing.LookAndFeel testLaf =
							(javax.swing.LookAndFeel) Class
								.forName(lafI[i].getClassName())
								.newInstance();
						if (testLaf.isSupportedLookAndFeel()) {
							javax.swing.JMenuItem item =
								new javax.swing.JMenuItem();
							item.setText(lafI[i].getName());
							item
								.addActionListener(
									new java
									.awt
									.event
									.ActionListener() {
								public void actionPerformed(
									java.awt.event.ActionEvent evt) {
									jMenuLafActionPerformed(evt);
								}
							});
							jMenuLaf.add(item);
							lafNames.add(lafI[i].getName());
						}
					} catch (Exception e) {
						// look And feel is not supported. Ignore it.
						if (debug)
							e.printStackTrace();
					}
				}
			}
			// add this menu to settings menu
			jMenu2.add(jMenuLaf);
		}
	}

	/**
	 * Initializes the menu item for setting the mozilla executable.
	 */
	private void initMozillaMenuItem() {
		jMenuItemMozilla = new javax.swing.JMenuItem();
		jMenuItemMozilla.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SELECT_MOZILLA"));
		jMenuItemMozilla
			.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItemMozillaActionPerformed(evt);
			}
		});
		jMenu2.add(jMenuItemMozilla);
	}

	/**
	 * Reads the path to the mozilla executable from the database.
	 */
	private void initMozilla() {
		// get Mozilla-path from DB, if not set on command line
		if (mozilla == null) {
			try {
				java.util.Properties settings = Proxy.idManager.settings;
				psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
				mozilla = dbi.selectConfiguration("mozilla.path").getValue();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if (!isMozilla(mozilla)) {
			mozilla = null;
		}
	}

	/**
	 * Changes Look and feel.
	 * @param evt the event for changing look and feel
	 */
	private void jMenuLafActionPerformed(java.awt.event.ActionEvent evt) {
		String lafName = ((javax.swing.JMenuItem) evt.getSource()).getText();
		if (!setLookAndFeel(lafName)) {
			javax.swing.JOptionPane.showMessageDialog(
				this,
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"LOOK_AND_FEEL")
					+ " \""
					+ lafName
					+ "\" "
					+ java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"IS_NOT_SUPPORTED"),
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"LOOK_AND_FEEL_ERROR"),
				javax.swing.JOptionPane.ERROR_MESSAGE);

		} else {
			// write LookAndFeel to database
			try {
				java.util.Properties settings = Proxy.idManager.settings;
				psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
				psman.data.Configuration c =
					new psman.data.Configuration("gui.lookandfeel", lafName);
				try {
					dbi.insert(c);
				} catch (Exception e) {
					dbi.update(c);
				}
			} catch (Exception e) {
				javax.swing.JOptionPane.showMessageDialog(
					this,
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"ERROR_WRITING_CONFIGURATION")
						+ "\n\n"
						+ e.getMessage(),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"ERROR"),
					javax.swing.JOptionPane.ERROR_MESSAGE);
				if (debug)
					e.printStackTrace();
			}
		}
	}

	/**
	 * Sets the Look and Feel defined in <code>name</code>.
	 * @param name the name of the Look and Feel
	 * @return false, if an error occured, true otherwise.
	 */
	private boolean setLookAndFeel(String name) {
		if (name == null)
			return false;
		UIManager.LookAndFeelInfo[] lafI = UIManager.getInstalledLookAndFeels();
		for (int i = 0; i < lafI.length; i++) {
			if (name.equals(lafI[i].getName())) {
				try {
					UIManager.setLookAndFeel(lafI[i].getClassName());
					javax.swing.SwingUtilities.updateComponentTreeUI(
						this.getParent().getParent());
				} catch (Exception e) {
					if (debug) {
						System.out.println("Look&Feel cannot be started:");
						e.printStackTrace();
					}
					return false;
				}
				i = lafI.length;
			}
		}
		return true;
	}
	/**
	 * Shows a dialog to change the path to mozilla executable. Saves new setting
	 * to database.
	 * @param evt ignored
	 */
	private void jMenuItemMozillaActionPerformed(
		java.awt.event.ActionEvent evt) {
		javax.swing.JFileChooser jFileChooser = new javax.swing.JFileChooser();
		jFileChooser.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
		jFileChooser.setMultiSelectionEnabled(false);
		if (mozilla != null) {
			jFileChooser.setSelectedFile(new File(mozilla));
		} else {
			jFileChooser.setCurrentDirectory(null);
		}
		jFileChooser.setDialogTitle(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SELECT_MOZILLA"));
		boolean done = false;
		while (!done) {
			int ret =
				jFileChooser.showDialog(
					this,
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"Ok"));
			if (ret == javax.swing.JFileChooser.APPROVE_OPTION) {
				if (!isMozilla(jFileChooser.getSelectedFile().getPath())) {
					javax.swing.JOptionPane.showMessageDialog(
						this,
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"SELECTED_FILE")
							+ "\n\n"
							+ jFileChooser.getSelectedFile().getPath()
							+ "\n\n"
							+ java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"IS_NOT")
							+ " \"Mozilla\".",
						"Fehler",
						javax.swing.JOptionPane.ERROR_MESSAGE);
				} else {
					mozilla = jFileChooser.getSelectedFile().getPath();
					try {
						java.util.Properties settings =
							Proxy.idManager.settings;
						psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
						psman.data.Configuration c =
							new psman.data.Configuration(
								"mozilla.path",
								mozilla);
						try {
							dbi.insert(c);
						} catch (Exception e) {
							dbi.update(c);
						}
					} catch (Exception e) {
						javax.swing.JOptionPane.showMessageDialog(
							this,
							java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"ERROR_WRITING_CONFIGURATION")
								+ "\n\n"
								+ e.getMessage(),
							java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"ERROR"),
							javax.swing.JOptionPane.ERROR_MESSAGE);
						if (debug)
							e.printStackTrace();
					}
					done = true;
				}
			} else {
				done = true;
			}
		}
	}

	private void jCheckBoxMenuItem1ItemStateChanged(
		java.awt.event.ItemEvent evt) {
		//GEN-FIRST:event_jCheckBoxMenuItem1ItemStateChanged
		// Add your handling code here:
		boolean checked =
			evt.getStateChange() == java.awt.event.ItemEvent.SELECTED;
		if (cebit.proxy.Proxy.idManagerGUI != null)
			cebit
				.proxy
				.Proxy
				.idManagerGUI
				.getParent()
				.getParent()
				.getParent()
				.getParent()
				.setVisible(checked);
	} //GEN-LAST:event_jCheckBoxMenuItem1ItemStateChanged

	private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jMenuItem6ActionPerformed
		// Add your handling code here:
		reset(jMenuItem6);
	} //GEN-LAST:event_jMenuItem6ActionPerformed

	private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jMenuItem4ActionPerformed
		// Add your handling code here:
		try {
			java.util.Properties settings = Proxy.idManager.settings;
			final psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			psman.data.Configuration conf =
				new psman.data.Configuration("gui.locale", "en");
			try {
				dbi.insert(conf);
			} catch (Exception e) {
				dbi.update(conf);
			}
		} catch (Exception e) {
		}
		java.util.Locale.setDefault(java.util.Locale.ENGLISH);
		javax.swing.JComponent.setDefaultLocale(java.util.Locale.getDefault());
		reInitLocaleSettings();
	} //GEN-LAST:event_jMenuItem4ActionPerformed

	private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jMenuItem3ActionPerformed
		// Add your handling code here:
		try {
			java.util.Properties settings = Proxy.idManager.settings;
			final psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			psman.data.Configuration conf =
				new psman.data.Configuration("gui.locale", "de");
			try {
				dbi.insert(conf);
			} catch (Exception e) {
				dbi.update(conf);
			}
		} catch (Exception e) {
		}
		java.util.Locale.setDefault(java.util.Locale.GERMAN);
		javax.swing.JComponent.setDefaultLocale(java.util.Locale.getDefault());
		reInitLocaleSettings();
	} //GEN-LAST:event_jMenuItem3ActionPerformed

	private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jMenuItem2ActionPerformed
		// Add your handling code here:
		System.exit(0);
	} //GEN-LAST:event_jMenuItem2ActionPerformed

	private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_jMenuItem5ActionPerformed
		// Add your handling code here:
		AboutDialog ad =
			new AboutDialog(
				(javax.swing.JFrame) getParent()
					.getParent()
					.getParent()
					.getParent(),
				false);
		// center Dialog on top of this window
		java.awt.Dimension screenSize =
			java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		java.awt.Dimension ownSize = getSize();
		java.awt.Point ownPos =
			getParent().getParent().getParent().getParent().getLocation();
		java.awt.Dimension adSize = ad.getSize();
		int left =
			java.lang.Math.max(
				((ownSize.width - adSize.width) / 2) + ownPos.x,
				0);
		if (left + adSize.width > screenSize.width)
			left = screenSize.width - adSize.width;
		int top =
			java.lang.Math.max(
				((ownSize.height - adSize.height) / 2) + ownPos.y,
				0);
		if (top + adSize.height > screenSize.height)
			top = screenSize.height - adSize.height;
		ad.setLocation(left, top);

		ad.show();
	} //GEN-LAST:event_jMenuItem5ActionPerformed

	/**
	 * Inserts rules for a new role.
	 * @param role the role to insert rules for
	 * @param dbi the database interface
	 * @throws Exception if an error occures in the database connection
	 */
	private static void fixRules(String role, psman.dbi.DBI dbi)
		throws Exception {
		psman.data.Rule[] rules = dbi.selectRule();
		psman.data.Chain chain = dbi.selectChain("Pseudonymverwaltung");
		String action = "CALL ";
		String condition = "idman.rules.HasRole";
		String parameter = role;
		psman.data.Rule found = null;
		String target = null;
		for (int i = 0; i < rules.length; i++) {
			if (rules[i].getChain().getID() == chain.getID()) {
				if (rules[i].getCondition().equals(condition)) {
					if (rules[i].getParameter().equals(parameter)) {
						if (rules[i].getAction().startsWith(action)) {
							found = rules[i];
							target = rules[i].getAction().substring(5);
						} else {
							; // andere Action
						}
					} else {
						; // anderer Parameter
					}
				} else {
					; // falsche Bedingung
				}
			} else {
				; // falsche Kette
			}
		}
		if (found == null) {
			// ab der zweiten regel eintragen..
			// von hinten beginnen
			target = parameter;
			java.util.List list = new java.util.LinkedList();
			list.add(
				new psman.data.Rule(
					chain,
					condition,
					action + target,
					parameter));
			for (int i = 3;; i++) {
				psman.data.Rule rule = dbi.selectRule(chain.getID(), i);
				if (rule != null) {
					list.add(0, rule); // Reihenfolge umdrehen
				} else {
					break;
				}
			}
			//System.out.println(list);
			psman.data.Rule[] toChange =
				(psman.data.Rule[]) list.toArray(
					new psman.data.Rule[list.size()]);
			psman.data.Rule last = toChange[0];
			dbi.insert(
				new psman.data.Rule(
					chain,
					last.getRank() + 1,
					last.getCondition(),
					last.getAction(),
					last.getParameter()));
			for (int i = 1; i < toChange.length; i++) {
				//System.out.println("Working on: "+i+"("+toChange[i]+") becomes: "+last.getRank()+"("+last+")");
				int r = dbi.update(chain, last.getRank(), toChange[i]);
				last = toChange[i];
				if (debug)
					System.out.println(">>> " + r);
			}
		}
		psman.data.Chain tchain = dbi.selectChain(target);
		if (tchain == null) {
			// Regelkette eintragen...
			tchain = new psman.data.Chain(parameter);
			dbi.insert(tchain);
			String always = "idman.rules.AllwaysTrue";
			String valid = "idman.rules.ValidPseudonym";
			String accept = "ACCEPT";
			String reject = "REJECT";
			String none = "";
			String transaction =
				"idman.rules.PseudonymProvider.getTransactionPseudonym";
			dbi.insert(new psman.data.Rule(tchain, always, transaction, none));
			dbi.insert(new psman.data.Rule(tchain, valid, accept, none));
			dbi.insert(new psman.data.Rule(tchain, always, reject, none));
		} else {
			; // Regelkette vorhanden
		}
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.ButtonGroup buttonGroup1;
	private javax.swing.JButton jButton1;
	private javax.swing.JCheckBox jCheckBox1;
	private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem1;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JMenu jMenu1;
	private javax.swing.JMenu jMenu2;
	private javax.swing.JMenu jMenu3;
	private javax.swing.JMenu jMenu4;
	private javax.swing.JMenuBar jMenuBar1;
	private javax.swing.JMenuItem jMenuItem1;
	private javax.swing.JMenuItem jMenuItem2;
	private javax.swing.JMenuItem jMenuItem3;
	private javax.swing.JMenuItem jMenuItem4;
	private javax.swing.JMenuItem jMenuItem5;
	private javax.swing.JMenuItem jMenuItem6;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JPopupMenu jPopupMenu1;
	private javax.swing.JRadioButton jRadioButton1;
	private javax.swing.JRadioButton jRadioButton2;
	private javax.swing.JRadioButton jRadioButton3;
	private javax.swing.JPanel rolePanel;
	private javax.swing.JScrollPane scrollPanel;
	// End of variables declaration//GEN-END:variables
	private javax.swing.JMenu jMenuLaf;
	private javax.swing.JMenuItem jMenuItemMozilla;
	private Hashtable p3pnames = new Hashtable();

	/**
	 * Initialized P3P name substitution.
	 */
	private void initLocaleSettings() {
		String[] names =
			{
				"user.department",
				"user.name.prefix",
				"user.name.given",
				"user.name.family",
				"user.home-info.telecom.telephone.loccode",
				"user.home-info.telecom.telephone.number",
				"user.home-info.online.email",
				"user.home-info.postal.street",
				"user.home-info.postal.postalcode",
				"user.home-info.postal.city",
				"user.business-info.telecom.telephone.loccode",
				"user.business-info.telecom.telephone.number",
				"user.business-info.online.email",
				"user.business-info.postal.street",
				"user.business-info.postal.postalcode",
				"user.business-info.postal.city" };
		String[] others =
			{
				"current",
				"admin",
				"develop",
				"customization",
				"tailoring",
				"pseudo-analysis",
				"pseudo-decision",
				"individual-analysis",
				"individual-decision",
				"contact",
				"historical",
				"telemarketing",
				"other-purpose",
				"ours",
				"delivery",
				"same",
				"other-recipient",
				"unrelated",
				"public",
				"no-retention",
				"stated-purpose",
				"legal-requirement",
				"business-practices",
				"indefinitely" };
		for (int i = 0; i < names.length; i++) {
			p3pnames.put(
				"#" + names[i],
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					names[i]));
		}
		for (int i = 0; i < others.length; i++) {
			p3pnames.put(
				others[i],
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					others[i]));
		}

	}
	/**
	 * Update UI according to stored rules.
	 */
	private void initRules() {
		try {
			Properties settings = Proxy.idManager.settings;
			DBI dbi = Database.getDBI(settings);
			String[][] rules = getRules("Pseudonymverwaltung", dbi);
			String[] rule = rules[3];
			if (rule[1].equals("idman.rules.HasRole")) {
				jCheckBoxMenuItem1.setSelected(false);
			} else if (
				rule[1].equals("idman.rules.AllwaysTrue")
					&& rule[2].startsWith("idman.rules.PseudonymProvider.")) {
				jCheckBoxMenuItem1.setSelected(true);
			} else {
				jCheckBoxMenuItem1.setSelected(false);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	 * Update rules according to UI.
	 */
	private void setRules() {
		int rank = 3;
		try {
			Properties settings = Proxy.idManager.settings;
			DBI dbi = Database.getDBI(settings);
			String[][] rules = getRules("Pseudonymverwaltung", dbi);
			String[] rule = rules[rank];
			if (jCheckBoxMenuItem1.isSelected()) {
				if (rule[0].equals("idman.rules.AllwaysTrue")
					&& rule[1].startsWith("idman.rules.PseudonymProvider.")) {
					Chain chain = dbi.selectChain(rule[0]);
					String action =
						jRadioButton1.isSelected()
							? "idman.rules.PseudonymProvider.getPersonalPseudonym"
							: jRadioButton2.isSelected()
							? "idman.rules.PseudonymProvider.getRelationshipPseudonym"
							: "idman.rules.PseudonymProvider.getTransactionPseudonym";
					Rule r = new Rule(chain, rank, rule[1], action, rule[3]);
					dbi.update(chain, rank, r);
				} else {
					//do something real terrible
					}

			} else {
				jCheckBoxMenuItem1.setSelected(false);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
	/**
	 * Reinitializes localized gui items for this component and its subcomponents.
	 */
	private void reInitLocaleSettings() {
		initLocaleSettings();
		(
			(javax.swing.JFrame) getParent()
				.getParent()
				.getParent()
				.getParent())
				.setTitle(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Bitte_auswaehlen"));
		jMenu1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SESSION"));
		jMenuItem2.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"EXIT"));
		jMenu2.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SETTINGS"));
		jMenu3.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"LANGUAGE"));
		jMenuItem3.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"GERMAN"));
		jMenuItem4.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"ENGLISH"));
		jMenuItem6.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"REINIT"));
		jCheckBoxMenuItem1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SHOW_MANAGER"));
		jMenu4.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"HELP"));
		jMenuItem5.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"ABOUT"));
		jMenuItem1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"CLOSE_BROWSER_FOR_THIS_ROLE"));
		jButton1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"NEUE_ROLLE_ANLEGEN"));

		jMenuLaf.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"LOOK_AND_FEEL"));
		jMenuItemMozilla.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SELECT_MOZILLA"));

		jCheckBox1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Disable_role_related_linkability_use_instead"));
		jLabel1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Your_actions_and_data_can_be_linked"));
		jRadioButton1.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"by_each_website_separately"));
		jRadioButton2.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"by_all_websites"));
		jRadioButton3.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"never"));
		jLabel2.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"Rollen"));
		jLabel3.setText(
			java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				"SETTINGS"));

	}

	/**
	 * Resets the cebit demonstrator.
	 * @param item
	 */
	private void reset(final javax.swing.JComponent item) {
		// Add your handling code here:
		final Reinit reinit = new Reinit();
		final javax.swing.JDialog regui =
			new javax.swing.JDialog(
				(javax.swing.JFrame) getParent()
					.getParent()
					.getParent()
					.getParent());
		regui.getContentPane().add(
			new javax.swing.JLabel(
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"WORKING")));
		regui.pack();
		regui.show();
		(new Thread() {
			{
				setPriority(Thread.MIN_PRIORITY);
			}
			public void run() {
				item.setEnabled(false);
				try {
					idman.mngt.Context[] carr =
						cebit.proxy.Proxy.idManager.getExportContexts();
					for (int i = 0; i < carr.length; i++) {
						try {
							org.ssonet.net.SSONETProtocolStream stream =
								carr[i].getSSONETProtocolStream();
							stream.closeIn();
							stream.closeOut();
						} catch (java.io.IOException ioe) {
							// ignore it, socket is unusable
						}
					}
					reinit.reinit(Proxy.idManager.settings);

					java.util.Properties settings = Proxy.idManager.settings;
					final psman.dbi.DBI dbi =
						idman.dbi.Database.getDBI(settings);
					setRoles(dbi.selectRole());
				} catch (Exception e) {
					String msg = e.toString();
					String title =
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"ERROR_OCCURED");
					javax.swing.JOptionPane.showMessageDialog(
						Starter.this,
						msg,
						title,
						javax.swing.JOptionPane.ERROR_MESSAGE);
				} finally {
					javax.swing.SwingUtilities.invokeLater(new Runnable() {
						public void run() {
							regui.dispose();
							item.setEnabled(true);
						}
					});
				}
			}
		}).start();
	}

	/**
	 * Shows a dialog for editing role settings and registers changed settings at the
	 * appropriate places.
	 * @param role the role to edit setting for
	 * @param cancel true, if the "Cancel" button shall be shown, false otherwise
	 */
	private void editSettings(final String role, boolean cancel) {
		try {
			// fill data into VisitenKarte (Bussiness Card)
			final VisitenKarte vk = new VisitenKarte();
			java.util.Properties settings = Proxy.idManager.settings;
			final psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			psman.data.Chain pse = dbi.selectChain("Pseudonymverwaltung");
			String chainname = role;
			int i = 1;
			for (psman.data.Rule rule = null;
				(rule = dbi.selectRule(pse.getID(), i)) != null;
				i++) {
				if (rule.getCondition().equals("idman.rules.HasRole")
					&& rule.getParameter().equals(chainname)
					&& rule.getAction().startsWith("CALL ")) {
					chainname = rule.getAction().substring(5);
				}
			}
			pse = dbi.selectChain(chainname);
			// read all rules -> recursive
			String[][] ruleset = getRules(chainname, dbi);
			// read P3P rules
			AppelRuleSet conf = dbi.selectAppelRuleSet(role);
			if (conf != null) {
				org.w3c.dom.Document d =
					db.parse(
						new java.io.ByteArrayInputStream(
							conf.getValue().getBytes()));
				if (d != null) {
					org.w3c.dom.NodeList rl =
						d.getElementsByTagNameNS(appel, "RULE");
					boolean warned = false;
					for (int ii = 0, jj = rl.getLength(); ii < jj; ii++) {
						org.w3c.dom.Element r =
							(org.w3c.dom.Element) rl.item(ii);
						String behavior = r.getAttributeNS(appel, "behavior");
						org.w3c.dom.NodeList pl =
							r.getElementsByTagNameNS(p3p, "POLICY");
						for (int kk = 0, ll = pl.getLength(); kk < ll; kk++) {
							org.w3c.dom.Element p =
								(org.w3c.dom.Element) pl.item(kk);
							org.w3c.dom.NodeList sl =
								p.getElementsByTagNameNS(p3p, "STATEMENT");
							for (int mm = 0, nn = sl.getLength();
								mm < nn;
								mm++) {
								org.w3c.dom.Element s =
									(org.w3c.dom.Element) sl.item(mm);
								org.w3c.dom.NodeList gl =
									s.getElementsByTagNameNS(p3p, "DATA-GROUP");
								for (int oo = 0, pp = gl.getLength();
									oo < pp;
									oo++) {
									org.w3c.dom.Element g =
										(org.w3c.dom.Element) gl.item(oo);
									org.w3c.dom.NodeList dl =
										g.getElementsByTagNameNS(p3p, "DATA");
									for (int qq = 0, rr = dl.getLength();
										qq < rr;
										qq++) {
										org.w3c.dom.Element a =
											(org.w3c.dom.Element) dl.item(qq);
										String ref =
											a.getAttributeNS(p3p, "ref");
										if (ref == null || ref.length() < 1) {
											if (!warned)
												System.out.println(
													"Invalid appel-ruleset. Falling back to DOM Level 1 (ignoring namespace).");
											ref = a.getAttribute("ref");
											warned = true;
										}
										vk.setAllowed(
											ref,
											behavior.equals("request"));
									}
								}
							}
						}
					}
				}
			}
			// read personal data
			if (true) {
				psman.data.DataField[] datas =
					dbi.selectDataField((psman.data.TPartner) null);
				java.util.Properties props = new java.util.Properties();
				java.util.Date now = new java.util.Date();
				for (int j = 0; j < datas.length; j++) {
					if (datas[j].getValidFrom().before(now)
						&& (datas[j].getValidUntil().after(now)
							|| datas[j].getValidUntil().getTime() == 0)) {
						props.setProperty(
							datas[j].getName(),
							new String(datas[j].getValue()));
					}
				}
				vk.set(props);
			}
			// read the role icon
			BufferedImage roleImage = null;
			try {
				roleImage =
					javax.imageio.ImageIO.read(
						getClass().getResource("/idm/" + role + ".png"));
			} catch (Exception e) {
				if (debug) {
					System.out.println(
						"RoleImage for Role \"" + role + "\" not found.");
					e.printStackTrace();
				}
				roleImage =
					new BufferedImage(64, 64, BufferedImage.TYPE_INT_RGB);
			}
			// create the editor dialog
			final Editor e =
				new Editor(
					vk,
					ruleset,
					roleImage,
					role,
					!jCheckBox1.isSelected());
			//          int o = javax.swing.JOptionPane.showConfirmDialog(this, e, role, javax.swing.JOptionPane.OK_CANCEL_OPTION);
			//            if (o==javax.swing.JOptionPane.OK_OPTION) {
			// create a runnable containing the method to be called when settings are changed
			Runnable r = new Runnable() {
				public void run() {
					try {
							// Persnliche Daten erneuern
	java.util.Properties data = vk.getAll();
						java.util.Date now = new java.util.Date();
						java.util.Date never = new java.util.Date(0);
						for (java.util.Iterator it = data.keySet().iterator();
							it.hasNext();
							) {
							String s = (String) it.next();
							byte[] v = ((String) data.get(s)).getBytes();
							// System.out.println("Working on: "+s);
							psman.data.DataField[] older =
								dbi.selectDataField(s, null);
							psman.data.DataField current = null;
							boolean same = false;
							for (int j = 0; j < older.length; j++) {
								byte[] b = older[j].getValue();
								if (b.length == v.length) {
									same = true;
									for (int k = 0; k < b.length && same; k++)
										if (b[k] != v[k])
											same = false;
								}
								if (!same) {
									if (older[j].getValidFrom().before(now)
										&& (older[j].getValidUntil().after(now)
											|| older[j].getValidUntil().getTime()
												== 0)) {
										older[j] =
											new psman.data.DataField(
												older[j].getID(),
												null,
												older[j].getName(),
												older[j].getValue(),
												older[j].getValidFrom(),
												now);
										int r = dbi.update(older[j]);
										if (debug)
											System.out.println(
												"Discarded: "
													+ new String(
														older[j].getValue())
													+ " r: "
													+ r);
									}
								} else {
									current = older[j];
									// System.out.println("Reusing: "+new String(older[j].getValue()));
								}
								same = false;
								// reset this for another round!
							}
							if (current == null) {
								// owner, id, value, start, end
								psman.data.DataField d =
									new psman.data.DataField(
										null,
										s,
										v,
										now,
										never);
								int r = dbi.insert(d);
								if (debug)
									System.out.println(
										"Added: " + s + " r: " + r);
							} else {
								boolean modded = false;
								if (current.getValidFrom().after(now)) {
									current =
										new psman.data.DataField(
											current.getID(),
											null,
											s,
											v,
											now,
											current.getValidUntil());
									modded = true;
								}
								if (current.getValidUntil().before(now)
									&& current.getValidUntil().getTime() != 0) {
									current =
										new psman.data.DataField(
											current.getID(),
											null,
											s,
											v,
											current.getValidFrom(),
											never);
									modded = true;
								}
								if (modded) {
									int r = dbi.update(current);
									if (debug)
										System.out.println(
											"Updated: " + s + " r: " + r);
								}
							}
						}
						// Regeln zur Datenpreisgabe erneuern
						if (true) {
							org.w3c.dom.Document d = db.newDocument();
							org.w3c.dom.Element pruleset =
								d.createElementNS(appel, "appel:RULESET");
							pruleset.setAttributeNS(
								xmlns,
								"xmlns:appel",
								appel);
							pruleset.setAttributeNS(xmlns, "xmlns:p3p", p3p);
							d.appendChild(pruleset);
							String[] keys =
								(String[]) vk.get().keySet().toArray(
									new String[0]);
							for (int pi = 0; pi < keys.length; pi++) {
								org.w3c.dom.Element rule =
									d.createElementNS(appel, "appel:RULE");
								rule.setAttributeNS(
									appel,
									"appel:behavior",
									vk.allowed(keys[pi]) ? "request" : "block");
								org.w3c.dom.Element policy =
									d.createElementNS(p3p, "p3p:POLICY");
								org.w3c.dom.Element statement =
									d.createElementNS(p3p, "p3p:STATEMENT");
								org.w3c.dom.Element datagroup =
									d.createElementNS(p3p, "p3p:DATA-GROUP");
								org.w3c.dom.Element pdata =
									d.createElementNS(p3p, "p3p:DATA");
								pdata.setAttributeNS(p3p, "p3p:ref", keys[pi]);
								datagroup.appendChild(pdata);
								statement.appendChild(datagroup);
								policy.appendChild(statement);
								rule.appendChild(policy);
								pruleset.appendChild(rule);
							}
							if (false) {
								org.w3c.dom.Element rule =
									d.createElementNS(appel, "appel:RULE");
								rule.setAttributeNS(
									appel,
									"appel:behavior",
									"block");
								org.w3c.dom.Element other =
									d.createElementNS(appel, "appel:OTHERWISE");
								rule.appendChild(other);
								pruleset.appendChild(rule);
							}
							String pset = "</root>";
							java.io.ByteArrayOutputStream baos =
								new java.io.ByteArrayOutputStream();
							t.transform(
								new javax.xml.transform.dom.DOMSource(d),
								new javax.xml.transform.stream.StreamResult(
									baos));
							pset = new String(baos.toByteArray());
							AppelRuleSet conf = dbi.selectAppelRuleSet(role);
							if (conf != null) {
								conf = new AppelRuleSet(role, pset);
								dbi.update(conf);
							} else {
								conf = new AppelRuleSet(role, pset);
								dbi.insert(conf);
							}
						}
						// Regelkette zur Pseudonymverwaltung erneuern
						String[][] ruleset = e.getRules();
						java.util.Set chainnames = new java.util.HashSet();
						for (int i = 0; i < ruleset.length; i++)
							chainnames.add(ruleset[i][0]);
						for (java.util.Iterator it = chainnames.iterator();
							it.hasNext();
							) {
							String cn = (String) it.next();
							psman.data.Chain chain = dbi.selectChain(cn);
							if (chain != null) {
								int i = 1;
								for (psman.data.Rule r = null;
									(r = dbi.selectRule(chain.getID(), i))
										!= null;
									i++) {
									dbi.delete(r);
								}
							} else {
								dbi.insert(chain = new psman.data.Chain(cn));
							}
						}
						for (int i = 0; i < ruleset.length; i++) {
							dbi.insert(
								new psman.data.Rule(
									dbi.selectChain(ruleset[i][0]),
									ruleset[i][1],
									ruleset[i][2],
									ruleset[i][3]));
						}
						// write the new role icon.
						java.net.URL iconDirURL =
							getClass().getResource("/idm");
						File f =
							new File(
								new URI(
									iconDirURL.toString()
										+ new URI(
											null,
											null,
											"/" + role + ".png",
											null)
											.toString()));
						System.out.println("IconURI: " + f.getPath());
						javax.imageio.ImageIO.write(e.getRoleIcon(), "png", f);

						// update roles panel
						setRoles(dbi.selectRole());
					} catch (Exception e) {
						javax.swing.JOptionPane.showMessageDialog(
							Starter.this,
							e.getMessage(),
							e.toString(),
							javax.swing.JOptionPane.ERROR_MESSAGE);
						e.printStackTrace();
					}
				}
			};

			// create the settings frame
			javax.swing.JFrame f = null;
			if (cancel)
				f =
					new OkCancelFrame(
						e,
						java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"SettingsForRole")
							+ " \""
							+ role
							+ "\"",
						r);
			else
				f = new OkFrame(e, role, r);
			// center Dialog on top of this window
			f.setIconImage(
				new javax
					.swing
					.ImageIcon(
						getClass().getResource("/proxy/config_16x16.png"))
					.getImage());
			java.awt.Dimension screenSize =
				java.awt.Toolkit.getDefaultToolkit().getScreenSize();
			java.awt.Dimension ownSize = getSize();
			java.awt.Point ownPos =
				getParent().getParent().getParent().getParent().getLocation();
			java.awt.Dimension fSize = f.getSize();
			int left =
				java.lang.Math.max(
					((ownSize.width - fSize.width) / 2) + ownPos.x,
					0);
			if (left + fSize.width > screenSize.width)
				left = screenSize.width - fSize.width;
			int top =
				java.lang.Math.max(
					((ownSize.height - fSize.height) / 2) + ownPos.y,
					0);
			if (top + fSize.height > screenSize.height)
				top = screenSize.height - fSize.height;
			f.setLocation(left, top);
			// show settings frame
			f.show();
			//} else {
			//System.out.println("Abgebrochen, nichts geaendert.");
			//}
		} catch (MissingResourceException mre) {
			String[] msg =
				{
					"ERROR: Can't find description for icons.",
					"This means there are missing some files.",
					"To avoid this error please follow these steps:",
					"1) create directories drim/cebit/endorsed/cebit/proxy/gui",
					"2) create therein a file named description.properties",
					"3) put into the file one line containing:",
					"  Visitenkarte_Aendern_Beschreibung2=",
					"4) put your description after the = on the same line",
					"5) Ask Thomas, if that won't work." };
			String title = msg[0];
			int type = JOptionPane.ERROR_MESSAGE;
			JOptionPane.showMessageDialog(this, msg, title, type);
		} catch (Exception e) {
			javax.swing.JOptionPane.showMessageDialog(
				this,
				e.getMessage(),
				e.toString(),
				javax.swing.JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}
	}

	/**
	 * Starts the Mozilla browser.
	 * @param profile the mozilla profile to use (corresponds to the role)
	 * @return the mozilla process
	 */
	private Process startMozilla(String profile) {
		try {
			if (mozilla == null) {
				javax.swing.JOptionPane.showMessageDialog(
					this,
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"MOZILLA_PATH_ERROR_1")
						+ "\n\n"
						+ java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"MOZILLA_PATH_ERROR_2"),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"ERROR"),
					javax.swing.JOptionPane.ERROR_MESSAGE);
				jMenuItemMozillaActionPerformed(null);
			}
			if (mozilla != null) {
				Runtime r = Runtime.getRuntime();
				String[] cmd =
					{
						mozilla,
						"-P",
						profile.replace(' ', '_'),
						"http://localhost:8002/webshop/"
							+ java.util.ResourceBundle.getBundle(
								"cebit/proxy/gui/language").getString(
								"shop.html")};
				String[] env = {
				};

				System.out.println(
					"Starter: Running Mozilla with following command: "
						+ cmd[0]);
				java.io.File dir =
					new java.io.File(System.getProperty("user.home", "."));
				Process p = r.exec(cmd, env, dir);
				return p;
			} else {
				javax.swing.JOptionPane.showMessageDialog(
					this,
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"ERROR_STARTING_MOZILLA")
						+ "\n\n"
						+ java.util.ResourceBundle.getBundle(
							"cebit/proxy/gui/language").getString(
							"MOZILLA_PATH_ERROR_1")
						+ "\n\n",
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"ERROR"),
					javax.swing.JOptionPane.INFORMATION_MESSAGE);
			}
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * Starts the browser in a new thread and manages its output streams.
	 * @param role
	 * @param item
	 */
	private void startBrowser(
		final String role,
		final javax.swing.JComponent item) {
		// Add your handling code here:
		item.setEnabled(false);
		new Thread() {
			public void run() {
				try {
					final Process p = startMozilla(role);
					if (mozilla != null) {
						browserProcesses.put(role, p);
						if (p != null) {
							// threads fr Err und Out erzeugen.
							MozillaStreamReader msrErr =
								new MozillaStreamReader(p.getErrorStream());
							new MozillaStreamReader(p.getInputStream());
							try {
								msrErr.join();
							} catch (Exception e) {
								if (debug) {
									System.out.println(
										"Waiting for Mozilla to stop didn't work correctly:");
									e.printStackTrace();
								}
							};
						}
						javax
							.swing
							.SwingUtilities
							.invokeAndWait(new Runnable() {
							public void run() {
								browserProcesses.remove(role);
								try {
									java.util.Properties settings =
										Proxy.idManager.settings;
									final psman.dbi.DBI dbi =
										idman.dbi.Database.getDBI(settings);
									setRoles(dbi.selectRole());
								} catch (Exception e) {
								}
								item.setEnabled(true);
							}
						});
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		.start();
	}

	/**
	 * Kills the browser running under the given role.
	 * @param role the role to kill the browser for
	 */
	private void killBrowser(String role) {
		// Add your handling code here:
		try {
			System.out.println("Starter: try to kill browser. Role: " + role);
			Process p = (Process) browserProcesses.get(role);
			if (p != null)
				p.destroy();
			System.out.println("Starter: browser killed.");
			browserProcesses.remove(role);
			java.util.Properties settings = Proxy.idManager.settings;
			final psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			setRoles(dbi.selectRole());
		} catch (Exception e) {
			// Process not found: do nothing
		}
	}

	/**
	 * Shows the popup menu for killing the browser for the given role.
	 * @param role the role to show the popup for
	 * @param evt the menu showing event
	 */
	private void showKillPopup(String role, java.awt.event.MouseEvent evt) {
		if (evt.isPopupTrigger()) {
			java.awt.event.ActionListener stopper = new Stopper(this, role);
			java.awt.event.ActionListener[] listeners =
				jMenuItem1.getActionListeners();
			for (int i = 0; i < listeners.length; i++)
				jMenuItem1.removeActionListener(listeners[i]);
			jMenuItem1.addActionListener(stopper);
			jPopupMenu1.show(evt.getComponent(), evt.getX(), evt.getY());
		}
	}

	/**
	 * returns rule of a given rule chain
	 * @param chainname the name of the rule chain
	 * @param dbi the database interface
	 * @return a String array containing all rules of the given chain
	 * @throws Exception if an error occures in the database connection
	 */
	private String[][] getRules(String chainname, psman.dbi.DBI dbi)
		throws Exception {
		java.util.List result = new java.util.LinkedList();
		psman.data.Chain c = dbi.selectChain(chainname);
		if (c == null)
			return new String[][] {
				{
					chainname,
					"idman.rules.AllwaysTrue",
					"idman.rules.PseudonymProvider.getTransactionPseudonym",
					"N/A" },
				{
				chainname, "idman.rules.ValidPseudonym", "ACCEPT", "N/A" }, {
				chainname, "idman.rules.AllwaysTrue", "REJECT", "N/A" }
		};
		int i = 1;
		for (psman.data.Rule rule = null;
			(rule = dbi.selectRule(c.getID(), i)) != null;
			i++) {
			if (rule.getAction().startsWith("CALL ")) {
				String[][] addme = getRules(rule.getAction().substring(5), dbi);
				for (int j = 0; j < addme.length; j++)
					result.add(addme[j]);
			}
			String[] add =
				{
					rule.getChain().getName(),
					rule.getCondition(),
					rule.getAction(),
					rule.getParameter()};
			result.add(add);
		}
		return (String[][]) result.toArray(new String[0][]);
	}

	/**
	 * Shows the roles.
	 * @param roles an array containing all roles to show.
	 */
	private void setRoles(psman.data.Role[] roles) {
		rolePanel.removeAll();
		javax.swing.ImageIcon prefs =
			new javax.swing.ImageIcon(
				getClass().getResource("/proxy/config.png"));
		javax.swing.ImageIcon notSetIcon =
			new javax.swing.ImageIcon(
				new BufferedImage(64, 64, BufferedImage.TYPE_INT_RGB));
		for (int i = 0; i < roles.length; i++) {
			String role = roles[i].getName();
			java.awt.GridBagConstraints gbc1 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints gbc2 =
				new java.awt.GridBagConstraints();
			gbc1.weightx = 10.0;
			gbc1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gbc1.gridx = 1;
			gbc2.gridx = 2;
			javax.swing.ImageIcon icon = notSetIcon;
			try {
				java.net.URL iconDirURL = getClass().getResource("/idm");
				File f =
					new File(
						new URI(iconDirURL.toString() + "/" + role + ".png"));
				icon = new javax.swing.ImageIcon(javax.imageio.ImageIO.read(f));
			} catch (Exception e) {
				// if (debug) e.printStackTrace();
			}
			javax.swing.JButton browser = new javax.swing.JButton(icon);
			javax.swing.JButton prefser = new javax.swing.JButton(prefs);
			browser.addActionListener(new Runner(this, role));
			browser.addMouseListener(new Popper(this, role));
			prefser.addActionListener(new Changer(this, role));
			browser.setText(role);
			browser.setToolTipText(
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"START_BROWSER_TOOLTIP"));
			prefser.setToolTipText(
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"CHANGE_SETTINGS_TOOLTIP"));
			browser.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			//browser.setMargin(new java.awt.Insets(2, 2, 2, 14));
			//prefser.setMargin(new java.awt.Insets(2, 2, 2, 2));
			browser.setEnabled(!browserProcesses.containsKey(role));
			rolePanel.add(browser, gbc1);
			rolePanel.add(prefser, gbc2);
		}
		rolePanel.invalidate();
		scrollPanel.invalidate();
		scrollPanel.validate();
		rolePanel.repaint();
	}

	/**
	 * Checks, whether the given filename is a mozilla executable. It checks,
	 * whether the file can be executed and whether it returns some String containing
	 * "Mozilla" when command line option "--version" is given.
	 * @param mozillaFile the full file name of the mozilla executable
	 * @return true, if it is mozilla, false otherwise
	 */
	public static boolean isMozilla(String mozillaFile) {
		try {
			if (debug)
				System.out.println("Mozilla-File: " + mozillaFile);
			File f = new File(mozillaFile);
			if (f.exists() && f.canRead() && f.isFile()) {
				// On windows mozilla does not print version info
				if (File.pathSeparatorChar == ';')
					return true;
				// check version output
				Runtime r = Runtime.getRuntime();
				String[] cmd = { mozillaFile, "--version" };
				String[] env = {
				};
				java.io.File dir =
					new java.io.File(System.getProperty("user.home", "."));
				Process p = r.exec(cmd, env, dir);
				MozillaTestWaiter mtw = new MozillaTestWaiter(p);
				int ret = 0;
				String version = new String("");
				byte buffer[] = new byte[32];
				do {
					ret = p.getInputStream().read(buffer);
					if (ret > 0)
						version = version + new String(buffer, 0, ret);
				} while (ret >= 0);
				mtw.destroy();
				if (p != null)
					p.destroy();
				if (debug)
					System.out.println("Mozilla output: " + version);
				if (version.indexOf("Mozilla") >= 0) {
					return true;
				}
			}
		} catch (Exception e) {
		}
		return false;
	}

	/**
	 * Starts the cebit demonstrator (user side)
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		//try to install additional Look & Feels
		try {
			Class test = Class.forName("com.birosoft.liquid.LiquidLookAndFeel");
			if (test == null)
				throw new ClassNotFoundException("com.birosoft.liquid.LiquidLookAndFeel not found.");
			UIManager.installLookAndFeel(
				"Liquid",
				"com.birosoft.liquid.LiquidLookAndFeel");
		} catch (ClassNotFoundException cnfe) {
			if (debug)
				System.out.println("Liquid Look&Feel not found.");
		}
		// at first, set default look&feel
		javax.swing.UIManager.setLookAndFeel(
			javax.swing.UIManager.getSystemLookAndFeelClassName());

		String[] argsen = {
			// Per Kommandozeile -root ndern
			// *************** PFAD ANPASSEN *****************
			"-root", "/home/kriegel/work/idmjigsaw/Jigsaw/" };
		for (int i = 0; i < args.length; i++) {
			if ("-root".equals(args[i]))
				if (i + 1 < args.length)
					argsen[1] = args[++i];
				else
					System.out.println("Parameter fr -root fehlt.");
			if ("-mozilla".equals(args[i]))
				if (i + 1 < args.length)
					mozilla = args[++i];
				else
					System.out.println("Parameter fr -mozilla fehlt.");
		}
		/*
		org.w3c.www.protocol.http.HttpIDMConnection.debug=true;
		org.w3c.www.protocol.http.HttpIDMServer.debug=true;
		org.w3c.www.protocol.http.HttpIDMManager.debug=true;
		org.ssonet.io.ByteIOStream.debug=true;
		org.ssonet.net.SSONETProtocolStream.debug=true;
		idman.mngt.impl.P3PFilterStream.debug=true;
		 */
		org.w3c.jigsaw.daemon.ServerHandlerManager.main(argsen);
		javax.swing.JFrame f =
			new javax.swing.JFrame(
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"Bitte_auswaehlen"));
		Starter ds = new Starter();
		f.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		f.setJMenuBar(ds.jMenuBar1);
		f.getContentPane().add(ds);
		f.setSize(300, 500);
		// center Frame on screen
		java.awt.Dimension screenSize =
			java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		java.awt.Dimension ownDimension = f.getSize();
		f.setLocation(
			(screenSize.width - ownDimension.width) / 2,
			(screenSize.height - ownDimension.height) / 2);

		javax.swing.JWindow w = new javax.swing.JWindow();
		javax.swing.JLabel l =
			new javax.swing.JLabel(
				java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"WORKING"),
				javax.swing.JLabel.CENTER);
		w.getContentPane().add(l);
		w.setSize(ownDimension);
		w.setLocation(
			(screenSize.width - ownDimension.width) / 2,
			(screenSize.height - ownDimension.height) / 2);
		w.show();
		// initialize the identity manager
		try {
			java.net.URL u =
				new java.net.URL("http://localhost:8004/servlet/SetupServlet");
			u.getContent();
		} catch (java.io.IOException ioe) {
			// Mostly due: Authentication is already required -> ignore
		}
		// set initial look and feel
		cebit
			.proxy
			.Proxy
			.idManagerGUI
			.getParent()
			.getParent()
			.getParent()
			.getParent()
			.setVisible(false);
		ds.initMozilla();
		String currentLaf = null;
		try {
			java.util.Properties settings = Proxy.idManager.settings;
			psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			psman.data.Configuration conf =
				dbi.selectConfiguration("gui.lookandfeel");
			if (conf != null)
				currentLaf = conf.getValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		ds.setLookAndFeel(currentLaf);
		String currentLocale = null;
		try {
			java.util.Properties settings = Proxy.idManager.settings;
			psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			psman.data.Configuration conf =
				dbi.selectConfiguration("gui.locale");
			if (conf != null)
				currentLocale = conf.getValue();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if ("de".equals(currentLocale))
			java.util.Locale.setDefault(java.util.Locale.GERMAN);
		if ("en".equals(currentLocale))
			java.util.Locale.setDefault(java.util.Locale.ENGLISH);
		javax.swing.JComponent.setDefaultLocale(java.util.Locale.getDefault());
		ds.reInitLocaleSettings();
		// get and show available roles
		psman.data.Role[] roles = new Role[0];
		try {
			java.util.Properties settings = Proxy.idManager.settings;
			psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			roles = dbi.selectRole();
		} catch (Exception e) {
		}
		ds.setRoles(roles);
		Proxy.idManager.listener = new Listener(ds);
		ds.initRules();
		w.dispose();
		f.show();
		try {
			java.util.Properties settings = Proxy.idManager.settings;
			psman.dbi.DBI dbi = idman.dbi.Database.getDBI(settings);
			for (int i = 0; i < roles.length; i++) {
				AppelRuleSet conf = dbi.selectAppelRuleSet(roles[i].getName());
				if (conf == null)
					ds.editSettings(roles[i].getName(), false);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	static class Runner implements java.awt.event.ActionListener {
		Starter ds = null;
		String role = null;
		Runner(Starter ds, String role) {
			this.ds = ds;
			this.role = role;
		}
		public void actionPerformed(java.awt.event.ActionEvent e) {
			this.ds.startBrowser(role, (javax.swing.JComponent) e.getSource());
		}
	}
	static class Popper extends java.awt.event.MouseAdapter {
		Starter ds = null;
		String role = null;
		Popper(Starter ds, String role) {
			this.ds = ds;
			this.role = role;
		}
		public void mousePressed(java.awt.event.MouseEvent evt) {
			// Add your handling code here:
			if (!((javax.swing.JComponent) evt.getSource()).isEnabled())
				this.ds.showKillPopup(role, evt);
		}
	}
	static class Stopper implements java.awt.event.ActionListener {
		Starter ds = null;
		String role = null;
		Stopper(Starter ds, String role) {
			this.ds = ds;
			this.role = role;
		}
		public void actionPerformed(java.awt.event.ActionEvent e) {
			System.out.println("Killing: " + role);
			this.ds.killBrowser(role);
		}
	}
	static class Changer implements java.awt.event.ActionListener {
		Starter ds = null;
		String role = null;
		Changer(Starter ds, String role) {
			this.ds = ds;
			this.role = role;
		}
		public void actionPerformed(java.awt.event.ActionEvent e) {
			this.ds.editSettings(role, true);
		}
	}

	static class MozillaTestWaiter extends Thread {
		private long start;
		private Process mozillaProcess = null;

		MozillaTestWaiter(Process p) {
			start = System.currentTimeMillis();
			mozillaProcess = p;
			this.setPriority(Thread.MIN_PRIORITY);
			this.start();
		}

		public void run() {
			if ((mozillaProcess != null)
				&& (System.currentTimeMillis() > start + 15000)) {
				try {
					mozillaProcess.destroy();
				} catch (Exception e) {
				}
			}
		}

		public void destroy() {
			mozillaProcess = null;
		}
	}

	static class MozillaStreamReader extends Thread {
		private InputStream is = null;

		MozillaStreamReader(InputStream is) {
			this.is = is;
			this.setPriority(Thread.NORM_PRIORITY);
			this.start();
		}

		public void run() {
			if (is != null) {
				try {
					for (int i = 0;(i = is.read()) >= 0;) {
						System.out.write(i);
					}
					is.close();
				} catch (IOException ioe) {
					if (debug)
						ioe.printStackTrace();
				}
			}
		}
	}
	static class Listener implements P3PListener {
		Starter starter = null;

		Listener(Starter starter) {
			this.starter = starter;
		}
		/* (non-Javadoc)
		 * @see idman.mngt.impl.P3PListener#notifyDetect(idman.mngt.Context)
		 */
		public void notifyDetect(Context context) {
			String role = context.getRole().getName();
			String title = "DETECTION_ENABLED";
			String type = getDetection(context);
			boolean detectable = isDetectable(context);
			String page = createDetectionPage(role, title, type, detectable);
			javax.swing.ImageIcon icon = null;
			try {
				java.net.URL iconDirURL = getClass().getResource("/idm");
				File f =
					new File(
						new URI(iconDirURL.toString() + "/" + role + ".png"));
				icon = new javax.swing.ImageIcon(javax.imageio.ImageIO.read(f));
			} catch (Exception e) {
				// if (debug) e.printStackTrace();
			}
			if (icon == null)
				JOptionPane.showMessageDialog(
					starter,
					new javax.swing.JLabel(page),
					i18n(title),
					JOptionPane.INFORMATION_MESSAGE);
			else
				JOptionPane.showMessageDialog(
					starter,
					new javax.swing.JLabel(page),
					i18n(title),
					JOptionPane.INFORMATION_MESSAGE,
					icon);
		}

		/**
		 * @param context
		 * @return
		 */
		private boolean isDetectable(Context context) {
			boolean result = false;
			try {
				DBI dbi = Database.getDBI(context);
				Pseudonym p = context.getPseudonym();
				SecretKey secretKey = p.getMasterKey();
				byte[] id = secretKey.getID();
				PublicKey signedKey = dbi.selectPublicKey(id);
				Type type = dbi.selectType(Management.IDENTITY_CA);
				TPartner[] trustees = dbi.selectTPartner(type);
				PublicKey[] signKeys = new PublicKey[trustees.length];
				for (int i = 0; i < trustees.length; i++) {
					signKeys[i] = trustees[i].getPublicKey();
				}
				Certificate certs[] =
					dbi.selectCertificate(signedKey, signKeys);
				result = certs != null && certs.length > 0;
			} catch (Exception e) {
				e.printStackTrace();
			}
			return result;
		}
		private String getDetection(Context context) {
			String[] types =
				{
					"personal",
					"role",
					"rolerelation",
					"relation",
					"transaction" };
			String[] names =
				{
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"idman_rules_PseudonymProvider_getPersonalPseudonym"),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"idman_rules_PseudonymProvider_getRolePseudonym"),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"idman_rules_PseudonymProvider_getRoleRelationPseudonym"),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"idman_rules_PseudonymProvider_getRelationPseudonym"),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"idman_rules_PseudonymProvider_getTransactionPseudonym"),
					java.util.ResourceBundle.getBundle(
						"cebit/proxy/gui/language").getString(
						"Fehler"),
					};
			int idx = 0;
			try {
				DBI dbi = Database.getDBI(context);

				PseudonymType pt =
					dbi.selectPseudonymType(context.getPseudonym())[0];
				for (idx = 0; idx < types.length; idx++) {
					if (types[idx].equals(pt.getName())) {
						break;
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			return names[idx];
		}
		/* (non-Javadoc)
		 * @see idman.mngt.impl.P3PListener#allowDetect(idman.mngt.Context)
		 */
		public boolean allowDetect(Context context) {
			String role = context.getRole().getName();
			String title = "ALLOW_DETECT";
			String type = getDetection(context);
			boolean detectable = isDetectable(context);
			String page = createDetectionPage(role, title, type, detectable);
			javax.swing.ImageIcon icon = null;
			try {
				java.net.URL iconDirURL = getClass().getResource("/idm");
				File f =
					new File(
						new URI(iconDirURL.toString() + "/" + role + ".png"));
				icon = new javax.swing.ImageIcon(javax.imageio.ImageIO.read(f));
			} catch (Exception e) {
				// if (debug) e.printStackTrace();
			}
			boolean result =
				(icon == null
					? JOptionPane.showConfirmDialog(
						starter,
						new javax.swing.JLabel(page),
						i18n(title),
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE)
					: JOptionPane.showConfirmDialog(
						starter,
						new javax.swing.JLabel(page),
						i18n(title),
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE,
						icon))
					== JOptionPane.YES_OPTION;
			return result;
		}

		/* (non-Javadoc)
		 * @see idman.mngt.impl.P3PListener#notifySent(java.lang.String[], java.lang.String[], java.lang.String[], java.lang.String, idman.mngt.Context)
		 */
		public void notifySent(
			String[] ids,
			String[] recipient,
			String[] purpose,
			String retention,
			Context context) {
			String role = context.getRole().getName();
			String title = "DATA_SENT.";
			String type = getDetection(context);
			boolean detectable = isDetectable(context);
			String page =
				createDataPage(
					ids,
					purpose,
					recipient,
					retention,
					role,
					title,
					type,
					detectable);
			javax.swing.ImageIcon icon = null;
			try {
				java.net.URL iconDirURL = getClass().getResource("/idm");
				File f =
					new File(
						new URI(iconDirURL.toString() + "/" + role + ".png"));
				icon = new javax.swing.ImageIcon(javax.imageio.ImageIO.read(f));
			} catch (Exception e) {
				// if (debug) e.printStackTrace();
			}
			if (icon == null)
				JOptionPane.showMessageDialog(
					starter,
					new javax.swing.JLabel(page),
					i18n(title),
					JOptionPane.INFORMATION_MESSAGE);
			else
				JOptionPane.showMessageDialog(
					starter,
					new javax.swing.JLabel(page),
					i18n(title),
					JOptionPane.INFORMATION_MESSAGE,
					icon);
		}

		/* (non-Javadoc)
		 * @see idman.mngt.impl.P3PListener#notifyReceived(java.lang.String[], java.lang.String[], java.lang.String[], java.lang.String, idman.mngt.Context)
		 */
		public void notifyReceived(
			String[] ids,
			String[] recipient,
			String[] purpose,
			String retention,
			Context context) {
			String role = context.getRole().getName();
			String title = "DATA_RECEIVED.";
			String type = getDetection(context);
			boolean detectable = isDetectable(context);
			String page =
				createDataPage(
					ids,
					purpose,
					recipient,
					retention,
					role,
					title,
					type,
					detectable);
			javax.swing.ImageIcon icon = null;
			try {
				java.net.URL iconDirURL = getClass().getResource("/idm");
				File f =
					new File(
						new URI(iconDirURL.toString() + "/" + role + ".png"));
				icon = new javax.swing.ImageIcon(javax.imageio.ImageIO.read(f));
			} catch (Exception e) {
				// if (debug) e.printStackTrace();
			}
			if (icon == null)
				JOptionPane.showMessageDialog(
					starter,
					new javax.swing.JLabel(page),
					i18n(title),
					JOptionPane.INFORMATION_MESSAGE);
			else
				JOptionPane.showMessageDialog(
					starter,
					new javax.swing.JLabel(page),
					i18n(title),
					JOptionPane.INFORMATION_MESSAGE,
					icon);
		}

		/* (non-Javadoc)
		 * @see idman.mngt.impl.P3PListener#allowSend(java.lang.String[], java.lang.String[], java.lang.String[], java.lang.String, idman.mngt.Context)
		 */
		public boolean allowSend(
			String[] ids,
			String[] recipient,
			String[] purpose,
			String retention,
			Context context) {

			if (!askUser)
				return false;
			String role = context.getRole().getName();
			String title = "SEND_DATA";
			String type = getDetection(context);
			boolean detectable = isDetectable(context);
			String page =
				createDataPage(
					ids,
					purpose,
					recipient,
					retention,
					role,
					title,
					type,
					detectable);
			javax.swing.ImageIcon icon = null;
			try {
				java.net.URL iconDirURL = getClass().getResource("/idm");
				File f =
					new File(
						new URI(iconDirURL.toString() + "/" + role + ".png"));
				icon = new javax.swing.ImageIcon(javax.imageio.ImageIO.read(f));
			} catch (Exception e) {
				// if (debug) e.printStackTrace();
			}
			boolean result =
				(icon == null
					? JOptionPane.showConfirmDialog(
						starter,
						new javax.swing.JLabel(page),
						i18n(title),
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE)
					: JOptionPane.showConfirmDialog(
						starter,
						new javax.swing.JLabel(page),
						i18n(title),
						JOptionPane.YES_NO_OPTION,
						JOptionPane.QUESTION_MESSAGE,
						icon))
					== JOptionPane.YES_OPTION;
			return result;
		}

		private String createDataPage(
			String[] data,
			String[] purpose,
			String[] recipient,
			String retention,
			String role,
			String title,
			String type,
			boolean detectable) {
			String page = "Fehler";
			long emit = System.currentTimeMillis();
			try {
				InputStream is =
					getClass().getResourceAsStream("/proxy/data.html");
				Reader r = new InputStreamReader(is);
				char[] c = new char[is.available()];
				r.read(c);
				page = new String(c);
			} catch (Exception e) {
				e.printStackTrace();
			}
			String _purpose = (String) starter.p3pnames.get(purpose[0]);
			for (int i = 1; i < purpose.length; i++)
				_purpose += "<br>" + starter.p3pnames.get(purpose[i]);
			String _recipient = (String) starter.p3pnames.get(recipient[0]);
			for (int i = 1; i < recipient.length; i++)
				_recipient += "<br>" + starter.p3pnames.get(recipient[i]);
			String _retention = (String) starter.p3pnames.get(retention);
			String _data = (String) starter.p3pnames.get(data[0]);
			for (int i = 1; i < data.length; i++)
				_data += "<br>" + starter.p3pnames.get(data[i]);
			String detect = new String[] { "YES", "NO" }
			[detectable ? 0 : 1];

			page = page.replaceAll("%TITLE%", i18n(title));
			page = page.replaceAll("%ROLE%", role);
			page = page.replaceAll("%RECOGNIZABLE%", type);
			page = page.replaceAll("%DETECTABLE%", i18n(detect));
			page = page.replaceAll("%PURPOSE%", _purpose);
			page = page.replaceAll("%RECIPIENT%", _recipient);
			page = page.replaceAll("%RETENTION%", _retention);
			page = page.replaceAll("%DATA%", _data);

			ResourceBundle rb =
				java.util.ResourceBundle.getBundle("cebit/proxy/gui/language");
			for (Enumeration e = rb.getKeys(); e.hasMoreElements();) {
				String key = (String) e.nextElement();
				String val = i18n(key);
				page = page.replaceAll(key, val);
			}
			System.out.println(
				"i18n: createDataPage " + (System.currentTimeMillis() - emit));
			return page;
		}
		private String createDetectionPage(
			String role,
			String title,
			String type,
			boolean detectable) {
			String page = "Fehler";
			long emit = System.currentTimeMillis();
			try {
				InputStream is =
					getClass().getResourceAsStream("/proxy/detection.html");
				Reader r = new InputStreamReader(is);
				char[] c = new char[is.available()];
				r.read(c);
				page = new String(c);
			} catch (Exception e) {
				e.printStackTrace();
			}
			String detect = new String[] { "YES", "NO" }
			[detectable ? 0 : 1];

			page = page.replaceAll("%TITLE%", i18n(title));
			page = page.replaceAll("%ROLE%", role);
			page = page.replaceAll("%RECOGNIZABLE%", type);
			page = page.replaceAll("%DETECTABLE%", i18n(detect));

			ResourceBundle rb =
				java.util.ResourceBundle.getBundle("cebit/proxy/gui/language");
			for (Enumeration e = rb.getKeys(); e.hasMoreElements();) {
				String key = (String) e.nextElement();
				String val = i18n(key);
				page = page.replaceAll(key, val);
			}
			System.out.println(
				"i18n: createDetectionPage "
					+ (System.currentTimeMillis() - emit));
			return page;
		}
		private String i18n(String n) {
			return java.util.ResourceBundle.getBundle(
				"cebit/proxy/gui/language").getString(
				n);
		}
	}
}
