/**
 * @version working
 * @author Thomas Kriegelstein
 * $Id: VisitenKarte.java,v 1.10 2004/05/24 13:20:59 tk4 Exp $
 */
package cebit.proxy.gui;


/**
 * Darstellung der persnlichen Daten und P3P-Regeln.
 * <br><b>Hinweis:</b> Die Oberflche wurde mit NetBeans/Forte erstellt.
 * @author Thomas Kriegelstein
 * @version $Id: VisitenKarte.java,v 1.10 2004/05/24 13:20:59 tk4 Exp $
 */
public class VisitenKarte extends javax.swing.JPanel{
    
    /**
     * Contains the visiting card description with the highlighting currently active.
     */
    private String vcDescription;
    
    /**
     * Konstruktor.
     */
    public VisitenKarte() {
        setVcDescription(false);
        initComponents();
        javax.swing.ComboBoxModel cbm = prefix.getModel();
        Object[] data = new Object[cbm.getSize()];
        for (int i=0; i<data.length; i++) {
            data[i] = java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString((String)cbm.getElementAt(i));
        }
        prefix.setModel(new javax.swing.DefaultComboBoxModel(data));    
        initToolTips();
    }
    /**
     * Die persnlichen Daten.
     */
    java.util.Properties p = new java.util.Properties();
    /**
     * Setzt die persnlichen Daten und aktaulisiert die Darstellung.
     */
    public void set(java.util.Properties p) {
        this.p = p;
        department.setText(p.getProperty("#user.department",""));
        prefix.setSelectedItem(p.getProperty("#user.name.prefix",""));
        given.setText(p.getProperty("#user.name.given",""));
        family.setText(p.getProperty("#user.name.family",""));
        String s = "#user.business-info.";
        business_loccode.setText(p.getProperty(s+"telecom.telephone.loccode",""));
        business_number.setText(p.getProperty(s+"telecom.telephone.number",""));
        business_email.setText(p.getProperty(s+"online.email",""));
        business_street.setText(p.getProperty(s+"postal.street",""));
        business_postalcode.setText(p.getProperty(s+"postal.postalcode",""));
        business_city.setText(p.getProperty(s+"postal.city",""));
        s="#user.home-info.";
        home_loccode.setText(p.getProperty(s+"telecom.telephone.loccode",""));
        home_number.setText(p.getProperty(s+"telecom.telephone.number",""));
        home_email.setText(p.getProperty(s+"online.email",""));
        home_street.setText(p.getProperty(s+"postal.street",""));
        home_postalcode.setText(p.getProperty(s+"postal.postalcode",""));
        home_city.setText(p.getProperty(s+"postal.city",""));
        updateView();
        updateIcons();
    }
    /**
     * Liefert abhngig von geschftlich/privat die persnlichen Daten.
     */
    public java.util.Properties get() {
        java.util.Properties p = new java.util.Properties();
        p.setProperty("#user.department",department.getText());
        p.setProperty("#user.name.prefix",(String)prefix.getSelectedItem());
        p.setProperty("#user.name.given",given.getText());
        p.setProperty("#user.name.family",family.getText());
        String s="#user.business-info.";
        p.setProperty(s+"telecom.telephone.loccode",business_loccode.getText());
        p.setProperty(s+"telecom.telephone.number",business_number.getText());
        p.setProperty(s+"online.email",business_email.getText());
        p.setProperty(s+"postal.street",business_street.getText());
        p.setProperty(s+"postal.postalcode",business_postalcode.getText());
        p.setProperty(s+"postal.city",business_city.getText());
        s="#user.home-info.";
        p.setProperty(s+"telecom.telephone.loccode",home_loccode.getText());
        p.setProperty(s+"telecom.telephone.number",home_number.getText());
        p.setProperty(s+"online.email",home_email.getText());
        p.setProperty(s+"postal.street",home_street.getText());
        p.setProperty(s+"postal.postalcode",home_postalcode.getText());
        p.setProperty(s+"postal.city",home_city.getText());
        return p;
    }
    /**
     * Liefert alle persnlichen Daten.
     */
    public java.util.Properties getAll() {
        return get();
    }
    /**
     * Liefert die Nutzereinstellung, ob Datenbertragung erlaubt ist.
     * @param name Identifikator der Daten.
     * @return <b>true</b>, wenn die Daten bermittelt werden drfen.
     */
    public boolean allowed(String name) {
        if (false) return true;
        else if (name.equals("#user.department")) return departmentToggle.isSelected();
        else if (name.equals("#user.name.prefix")) return prefixToggle.isSelected();
        else if (name.equals("#user.name.given")) return givenToggle.isSelected();
        else if (name.equals("#user.name.family")) return familyToggle.isSelected();
        else if (name.equals("#user.home-info.telecom.telephone.loccode")) return home_telephoneToggle.isSelected();
        else if (name.equals("#user.home-info.telecom.telephone.number")) return home_telephoneToggle.isSelected();
        else if (name.equals("#user.home-info.online.email")) return home_emailToggle.isSelected();
        else if (name.equals("#user.home-info.postal.street")) return home_streetToggle.isSelected();
        else if (name.equals("#user.home-info.postal.postalcode")) return home_cityToggle.isSelected();
        else if (name.equals("#user.home-info.postal.city")) return home_cityToggle.isSelected();
        else if (name.equals("#user.business-info.telecom.telephone.loccode")) return business_telephoneToggle.isSelected();
        else if (name.equals("#user.business-info.telecom.telephone.number")) return business_telephoneToggle.isSelected();
        else if (name.equals("#user.business-info.online.email")) return business_emailToggle.isSelected();
        else if (name.equals("#user.business-info.postal.street")) return business_streetToggle.isSelected();
        else if (name.equals("#user.business-info.postal.postalcode")) return business_cityToggle.isSelected();
        else if (name.equals("#user.business-info.postal.city")) return business_cityToggle.isSelected();
        else return false;
    }
    /**
     * Legt fr die Darstellung fest, ob Daten bertragen werden drfen.
     * @param name Identifikator der Daten.
     * @param b <b>true</b> wenn die Daten bertragen werden drfen.
     */
    public void setAllowed(String name, boolean b) {
        if (debug) System.out.println(name+": "+b);
        if (false);
        else if (name.equals("#user.department")) { departmentToggle.setSelected(b); }
        else if (name.equals("#user.name")) { prefixToggle.setSelected(b); givenToggle.setSelected(b); familyToggle.setSelected(b); }
        else if (name.equals("#user.name.prefix")) { prefixToggle.setSelected(b); }
        else if (name.equals("#user.name.given")) { givenToggle.setSelected(b); }
        else if (name.equals("#user.name.family")) { familyToggle.setSelected(b); }
        else if (name.equals("#user.home-info.telecom.telephone.loccode")) { home_telephoneToggle.setSelected(b); }
        else if (name.equals("#user.home-info.telecom.telephone.number")) { home_telephoneToggle.setSelected(b); }
        else if (name.equals("#user.home-info.online.email")) { home_emailToggle.setSelected(b); }
        else if (name.equals("#user.home-info.postal.street")) { home_streetToggle.setSelected(b); }
        else if (name.equals("#user.home-info.postal.postalcode")) { home_cityToggle.setSelected(b); }
        else if (name.equals("#user.home-info.postal.city")) { home_cityToggle.setSelected(b); }
        else if (name.equals("#user.business-info.telecom.telephone.loccode")) { business_telephoneToggle.setSelected(b); }
        else if (name.equals("#user.business-info.telecom.telephone.number")) { business_telephoneToggle.setSelected(b); }
        else if (name.equals("#user.business-info.online.email")) { business_emailToggle.setSelected(b); }
        else if (name.equals("#user.business-info.postal.street")) { business_streetToggle.setSelected(b); }
        else if (name.equals("#user.business-info.postal.postalcode")) { business_cityToggle.setSelected(b); }
        else if (name.equals("#user.business-info.postal.city")) { business_cityToggle.setSelected(b); }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jPanel12 = new javax.swing.JPanel();
        lockButton = new javax.swing.JToggleButton();
        jLabel16 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        prefixToggle = new javax.swing.JToggleButton();
        jLabel12 = new javax.swing.JLabel();
        given = new javax.swing.JTextField();
        givenToggle = new javax.swing.JToggleButton();
        family = new javax.swing.JTextField();
        familyToggle = new javax.swing.JToggleButton();
        prefix = new javax.swing.JComboBox();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel8 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        home_loccode = new javax.swing.JTextField();
        home_number = new javax.swing.JTextField();
        home_telephoneToggle = new javax.swing.JToggleButton();
        jLabel13 = new javax.swing.JLabel();
        home_email = new javax.swing.JTextField();
        home_emailToggle = new javax.swing.JToggleButton();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel14 = new javax.swing.JLabel();
        home_street = new javax.swing.JTextField();
        home_streetToggle = new javax.swing.JToggleButton();
        jLabel11 = new javax.swing.JLabel();
        home_postalcode = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        home_city = new javax.swing.JTextField();
        home_cityToggle = new javax.swing.JToggleButton();
        jPanel9 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        department = new javax.swing.JTextField();
        departmentToggle = new javax.swing.JToggleButton();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel3 = new javax.swing.JLabel();
        business_loccode = new javax.swing.JTextField();
        business_number = new javax.swing.JTextField();
        business_telephoneToggle = new javax.swing.JToggleButton();
        jLabel4 = new javax.swing.JLabel();
        business_email = new javax.swing.JTextField();
        business_emailToggle = new javax.swing.JToggleButton();
        jLabel6 = new javax.swing.JLabel();
        business_street = new javax.swing.JTextField();
        business_streetToggle = new javax.swing.JToggleButton();
        jLabel8 = new javax.swing.JLabel();
        business_postalcode = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        business_city = new javax.swing.JTextField();
        business_cityToggle = new javax.swing.JToggleButton();
        jSeparator3 = new javax.swing.JSeparator();
        jPanel5 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane2 = new javax.swing.JTextPane();
        jPanel4 = new javax.swing.JPanel();
        home_streetS = new javax.swing.JLabel();
        home_downS = new javax.swing.JSeparator();
        home_emailS = new javax.swing.JLabel();
        home_eS = new javax.swing.JLabel();
        home_telS = new javax.swing.JLabel();
        home_prefixS = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        home_givenS = new javax.swing.JLabel();
        home_familyS = new javax.swing.JLabel();
        home_slashS = new javax.swing.JPanel();
        home_loccodeS = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        home_numberS = new javax.swing.JLabel();
        home_postS = new javax.swing.JPanel();
        home_postalcodeS = new javax.swing.JLabel();
        home_cityS = new javax.swing.JLabel();
        jPanel10 = new javax.swing.JPanel();
        business_streetS = new javax.swing.JLabel();
        business_downS = new javax.swing.JSeparator();
        business_emailS = new javax.swing.JLabel();
        business_eS = new javax.swing.JLabel();
        business_telS = new javax.swing.JLabel();
        business_prefixS = new javax.swing.JLabel();
        business_upS = new javax.swing.JSeparator();
        business_departmentS = new javax.swing.JLabel();
        business_logoS = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        business_givenS = new javax.swing.JLabel();
        business_familyS = new javax.swing.JLabel();
        business_slashS = new javax.swing.JPanel();
        business_loccodeS = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        business_numberS = new javax.swing.JLabel();
        business_postS = new javax.swing.JPanel();
        business_postalcodeS = new javax.swing.JLabel();
        business_cityS = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();

        setLayout(new java.awt.CardLayout());

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 0, 10)));
        jLabel17.setText(vcDescription);
        jLabel17.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jLabel17, gridBagConstraints);

        lockButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/proxy/lock_closed.png")));
        lockButton.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/proxy/lock_open.png")));
        lockButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                lockButtonItemStateChanged(evt);
            }
        });

        jPanel12.add(lockButton);

        jLabel16.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Change_data_by_clicking_on_lock"));
        jPanel12.add(jLabel16);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jPanel12, gridBagConstraints);

        jPanel7.setLayout(new java.awt.GridBagLayout());

        jPanel7.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Allgemein"), javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14), java.awt.Color.blue));
        jLabel9.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Anrede:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel7.add(jLabel9, gridBagConstraints);

        prefixToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        prefixToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        prefixToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        prefixToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel7.add(prefixToggle, gridBagConstraints);

        jLabel12.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Name:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel7.add(jLabel12, gridBagConstraints);

        given.setColumns(10);
        given.setFont(new java.awt.Font("Dialog", 1, 12));
        given.setText("user.name.given");
        given.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel7.add(given, gridBagConstraints);

        givenToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        givenToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        givenToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        givenToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel7.add(givenToggle, gridBagConstraints);

        family.setColumns(14);
        family.setFont(new java.awt.Font("Dialog", 1, 12));
        family.setText("user.name.family");
        family.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel7.add(family, gridBagConstraints);

        familyToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        familyToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        familyToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        familyToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel7.add(familyToggle, gridBagConstraints);

        prefix.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "LEER", "HERR", "FRAU", "FRULEIN", "PROFESSOR" }));
        prefix.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel7.add(prefix, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jPanel7, gridBagConstraints);

        jPanel8.setLayout(new java.awt.GridBagLayout());

        jPanel8.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Privat"), javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14), java.awt.Color.blue));
        jLabel5.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Tel:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(jLabel5, gridBagConstraints);

        home_loccode.setColumns(10);
        home_loccode.setText("user.home-info.telecom.telephone.loccode");
        home_loccode.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(home_loccode, gridBagConstraints);

        home_number.setColumns(14);
        home_number.setText("user.home-info.telecom.telephone.number");
        home_number.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(home_number, gridBagConstraints);

        home_telephoneToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        home_telephoneToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        home_telephoneToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        home_telephoneToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel8.add(home_telephoneToggle, gridBagConstraints);

        jLabel13.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("e-Mail:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(jLabel13, gridBagConstraints);

        home_email.setColumns(28);
        home_email.setText("user.home-info.online.email");
        home_email.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 10.0;
        jPanel8.add(home_email, gridBagConstraints);

        home_emailToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        home_emailToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        home_emailToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        home_emailToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel8.add(home_emailToggle, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        jPanel8.add(jSeparator2, gridBagConstraints);

        jLabel14.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Strasse:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel8.add(jLabel14, gridBagConstraints);

        home_street.setColumns(28);
        home_street.setText("user.home-info.postal.street");
        home_street.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(home_street, gridBagConstraints);

        home_streetToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        home_streetToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        home_streetToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        home_streetToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel8.add(home_streetToggle, gridBagConstraints);

        jLabel11.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("PLZ:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(jLabel11, gridBagConstraints);

        home_postalcode.setColumns(10);
        home_postalcode.setText("user.home-info.postal.postalcode");
        home_postalcode.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(home_postalcode, gridBagConstraints);

        jLabel15.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Ort:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 10);
        jPanel8.add(jLabel15, gridBagConstraints);

        home_city.setColumns(14);
        home_city.setText("user.home-info.postal.city");
        home_city.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel8.add(home_city, gridBagConstraints);

        home_cityToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        home_cityToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        home_cityToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        home_cityToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel8.add(home_cityToggle, gridBagConstraints);

        jTabbedPane1.addTab(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Privatperson"), jPanel8);

        jPanel9.setLayout(new java.awt.GridBagLayout());

        jPanel9.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Business"), javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14), java.awt.Color.blue));
        jLabel10.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Organisation:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(jLabel10, gridBagConstraints);

        department.setColumns(28);
        department.setText("user.department");
        department.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 10.0;
        jPanel9.add(department, gridBagConstraints);

        departmentToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        departmentToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        departmentToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        departmentToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel9.add(departmentToggle, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        jPanel9.add(jSeparator1, gridBagConstraints);

        jLabel3.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Tel:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(jLabel3, gridBagConstraints);

        business_loccode.setColumns(10);
        business_loccode.setText("user.business-info.telecom.telephone.loccode");
        business_loccode.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(business_loccode, gridBagConstraints);

        business_number.setColumns(14);
        business_number.setText("user.business-info.telecom.telephone.number");
        business_number.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(business_number, gridBagConstraints);

        business_telephoneToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        business_telephoneToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        business_telephoneToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        business_telephoneToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel9.add(business_telephoneToggle, gridBagConstraints);

        jLabel4.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("e-Mail:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(jLabel4, gridBagConstraints);

        business_email.setColumns(28);
        business_email.setText("user.business-info.online.email");
        business_email.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(business_email, gridBagConstraints);

        business_emailToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        business_emailToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        business_emailToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        business_emailToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel9.add(business_emailToggle, gridBagConstraints);

        jLabel6.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Strasse:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 16;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.1;
        jPanel9.add(jLabel6, gridBagConstraints);

        business_street.setColumns(28);
        business_street.setText("user.business-info.postal.street");
        business_street.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 16;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(business_street, gridBagConstraints);

        business_streetToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        business_streetToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        business_streetToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        business_streetToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 16;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel9.add(business_streetToggle, gridBagConstraints);

        jLabel8.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("PLZ:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 17;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(jLabel8, gridBagConstraints);

        business_postalcode.setColumns(10);
        business_postalcode.setText("user.business-info.postal.postalcode");
        business_postalcode.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 17;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(business_postalcode, gridBagConstraints);

        jLabel7.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Ort:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 17;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 10);
        jPanel9.add(jLabel7, gridBagConstraints);

        business_city.setColumns(14);
        business_city.setText("user.business-info.postal.city");
        business_city.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 17;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel9.add(business_city, gridBagConstraints);

        business_cityToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/block.png.gif")));
        business_cityToggle.setMargin(new java.awt.Insets(0, 0, 0, 0));
        business_cityToggle.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/flow.png.gif")));
        business_cityToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateIcons(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 17;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel9.add(business_cityToggle, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 15;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 10);
        jPanel9.add(jSeparator3, gridBagConstraints);

        jTabbedPane1.addTab(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Geschftlich"), jPanel9);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel1.add(jTabbedPane1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.weighty = 10.0;
        jPanel1.add(jPanel5, gridBagConstraints);

        jButton1.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Anzeigen"));
        jButton1.setToolTipText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Als_Visitenkarte_darstellen"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.weightx = 10.0;
        gridBagConstraints.insets = new java.awt.Insets(20, 20, 10, 20);
        jPanel1.add(jButton1, gridBagConstraints);

        jScrollPane1.setBorder(null);
        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane1.setMinimumSize(new java.awt.Dimension(40, 50));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(200, 50));
        jTextArea1.setBackground((java.awt.Color) javax.swing.UIManager.getDefaults().get("Label.background"));
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Dialog", 1, 12));
        jTextArea1.setLineWrap(true);
        jTextArea1.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/description").getString("Visitenkarte_Aendern_Beschreibung2"));
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setBorder(null);
        jScrollPane1.setViewportView(jTextArea1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jScrollPane1, gridBagConstraints);

        add(jPanel1, "edit");

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 0, 10)));
        jScrollPane2.setBorder(null);
        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane2.setMinimumSize(new java.awt.Dimension(22, 80));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(10, 80));
        jTextPane2.setBackground((java.awt.Color) javax.swing.UIManager.getDefaults().get("Label.background"));
        jTextPane2.setEditable(false);
        jTextPane2.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Visitenkarte_Anzeigen_Beschreibung"));
        jScrollPane2.setViewportView(jTextPane2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel2.add(jScrollPane2, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBackground(java.awt.Color.white);
        jPanel4.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Privat"), javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14), java.awt.Color.blue));
        home_streetS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_streetS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_streetS.setText(home_street.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel4.add(home_streetS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        jPanel4.add(home_downS, gridBagConstraints);

        home_emailS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_emailS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_emailS.setText(home_email.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel4.add(home_emailS, gridBagConstraints);

        home_eS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_eS.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("e-Mail:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanel4.add(home_eS, gridBagConstraints);

        home_telS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_telS.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Tel:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanel4.add(home_telS, gridBagConstraints);

        home_prefixS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_prefixS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_prefixS.setText((String)prefix.getSelectedItem());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel4.add(home_prefixS, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBackground(java.awt.Color.white);
        home_givenS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_givenS.setText(given.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 10000.0;
        jPanel3.add(home_givenS, gridBagConstraints);

        home_familyS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_familyS.setText(family.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanel3.add(home_familyS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 10.0;
        jPanel4.add(jPanel3, gridBagConstraints);

        home_slashS.setLayout(new java.awt.GridBagLayout());

        home_slashS.setBackground(java.awt.Color.white);
        home_loccodeS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_loccodeS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_loccodeS.setText(home_loccode.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 10.0;
        home_slashS.add(home_loccodeS, gridBagConstraints);

        jLabel1.setText("/");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        home_slashS.add(jLabel1, gridBagConstraints);

        home_numberS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_numberS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_numberS.setText(home_number.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        home_slashS.add(home_numberS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel4.add(home_slashS, gridBagConstraints);

        home_postS.setLayout(new java.awt.GridBagLayout());

        home_postS.setBackground(java.awt.Color.white);
        home_postalcodeS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_postalcodeS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_postalcodeS.setText(home_postalcode.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 10.0;
        home_postS.add(home_postalcodeS, gridBagConstraints);

        home_cityS.setFont(new java.awt.Font("Dialog", 0, 12));
        home_cityS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        home_cityS.setText(home_city.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        home_postS.add(home_cityS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel4.add(home_postS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weighty = 10.0;
        jPanel2.add(jPanel4, gridBagConstraints);

        jPanel10.setLayout(new java.awt.GridBagLayout());

        jPanel10.setBackground(java.awt.Color.white);
        jPanel10.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Business"), javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14), java.awt.Color.blue));
        business_streetS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_streetS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_streetS.setText(business_street.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel10.add(business_streetS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        jPanel10.add(business_downS, gridBagConstraints);

        business_emailS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_emailS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_emailS.setText(business_email.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel10.add(business_emailS, gridBagConstraints);

        business_eS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_eS.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("e-Mail:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanel10.add(business_eS, gridBagConstraints);

        business_telS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_telS.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Tel:"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanel10.add(business_telS, gridBagConstraints);

        business_prefixS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_prefixS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_prefixS.setText((String)prefix.getSelectedItem());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel10.add(business_prefixS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        jPanel10.add(business_upS, gridBagConstraints);

        business_departmentS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_departmentS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_departmentS.setText(department.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanel10.add(business_departmentS, gridBagConstraints);

        business_logoS.setIcon(new javax.swing.ImageIcon(getClass().getResource("/idman/gui/images/who.gif")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel10.add(business_logoS, gridBagConstraints);

        jPanel11.setLayout(new java.awt.GridBagLayout());

        jPanel11.setBackground(java.awt.Color.white);
        business_givenS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_givenS.setText(given.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 10000.0;
        jPanel11.add(business_givenS, gridBagConstraints);

        business_familyS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_familyS.setText(family.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanel11.add(business_familyS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 10.0;
        jPanel10.add(jPanel11, gridBagConstraints);

        business_slashS.setLayout(new java.awt.GridBagLayout());

        business_slashS.setBackground(java.awt.Color.white);
        business_loccodeS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_loccodeS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_loccodeS.setText(business_loccode.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 10.0;
        business_slashS.add(business_loccodeS, gridBagConstraints);

        jLabel2.setText("/");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        business_slashS.add(jLabel2, gridBagConstraints);

        business_numberS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_numberS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_numberS.setText(business_number.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        business_slashS.add(business_numberS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel10.add(business_slashS, gridBagConstraints);

        business_postS.setLayout(new java.awt.GridBagLayout());

        business_postS.setBackground(java.awt.Color.white);
        business_postalcodeS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_postalcodeS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_postalcodeS.setText(business_postalcode.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 10.0;
        business_postS.add(business_postalcodeS, gridBagConstraints);

        business_cityS.setFont(new java.awt.Font("Dialog", 0, 12));
        business_cityS.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        business_cityS.setText(business_city.getText());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        business_postS.add(business_cityS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel10.add(business_postS, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 10.0;
        jPanel2.add(jPanel10, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 200.0;
        jPanel2.add(jPanel6, gridBagConstraints);

        jButton2.setText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Aendern"));
        jButton2.setToolTipText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Werte_und_Freigabe_aendern"));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.weightx = 10.0;
        gridBagConstraints.insets = new java.awt.Insets(20, 20, 10, 20);
        jPanel2.add(jButton2, gridBagConstraints);

        add(jPanel2, "show");

    }//GEN-END:initComponents

    private void lockButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_lockButtonItemStateChanged
        boolean toggle = (evt.getStateChange()==java.awt.event.ItemEvent.SELECTED);
        prefix.setEnabled(toggle);
        department.setEnabled(toggle);
        given.setEnabled(toggle);
        family.setEnabled(toggle);
        business_loccode.setEnabled(toggle);
        business_number.setEnabled(toggle);
        business_email.setEnabled(toggle);
        business_street.setEnabled(toggle);
        business_postalcode.setEnabled(toggle);
        business_city.setEnabled(toggle);
        
        home_loccode.setEnabled(toggle);
        home_number.setEnabled(toggle);
        home_email.setEnabled(toggle);
        home_street.setEnabled(toggle);
        home_postalcode.setEnabled(toggle);
        home_city.setEnabled(toggle);   
        setVcDescription(toggle);
        jLabel17.setText(vcDescription);
        jLabel17.invalidate();
    }//GEN-LAST:event_lockButtonItemStateChanged
    
    private void setVcDescription(boolean isChangesEnabled){
        if(isChangesEnabled){
            vcDescription = 
                "<html><font color=\"#FF0000\">"
                +java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Visitenkarte_Aendern_Beschreibung1")
                +"</font></html>";
        }else{
            vcDescription = 
                "<html>"
                +java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("Visitenkarte_Aendern_Beschreibung1")
                +" </html>";
        }
    }
            
    private void updateIcons() {
        // do not set the icons (requested by ninni because of user test)

        /*boolean business = business_telephoneToggle.isSelected()||business_emailToggle.isSelected()||
        business_streetToggle.isSelected()||business_cityToggle.isSelected()||
        departmentToggle.isSelected();
        boolean privat = home_telephoneToggle.isSelected()||home_emailToggle.isSelected()||
        home_streetToggle.isSelected()||home_cityToggle.isSelected();
        javax.swing.Icon flow = business_emailToggle.getSelectedIcon();
        javax.swing.Icon stop = business_emailToggle.getIcon();
        jTabbedPane1.setIconAt(0, privat?flow:stop);
        jTabbedPane1.setIconAt(1, business?flow:stop);*/
    }
    
    private void updateIcons(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateIcons
        updateIcons();
        // set tooltip text for the toggleButton changed
        if(evt.getSource() instanceof javax.swing.JToggleButton){
            if(((javax.swing.JToggleButton)evt.getSource()).isSelected()){
                ((javax.swing.JToggleButton)evt.getSource()).setToolTipText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("greenArrowToolTipText"));
            }else{
                ((javax.swing.JToggleButton)evt.getSource()).setToolTipText(java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("stopSignToolTipText"));
            }
        }
    }//GEN-LAST:event_updateIcons
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Add your handling code here:
        ((java.awt.CardLayout)getLayout()).show(this, "edit");
    }//GEN-LAST:event_jButton2ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Add your handling code here:
        updateView();
        ((java.awt.CardLayout)getLayout()).show(this, "show");
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /** Frischt die Darstellung der Visitenkarte auf. */
    public void updateView() {
        business_departmentS.setText(department.getText());
        business_prefixS.setText((String)prefix.getSelectedItem());
        business_givenS.setText(given.getText());
        business_familyS.setText(family.getText());
        business_loccodeS.setText(business_loccode.getText());
        business_numberS.setText(business_number.getText());
        business_emailS.setText(business_email.getText());
        business_streetS.setText(business_street.getText());
        business_postalcodeS.setText(business_postalcode.getText());
        business_cityS.setText(business_city.getText());
        
        home_prefixS.setText((String)prefix.getSelectedItem());
        home_givenS.setText(given.getText());
        home_familyS.setText(family.getText());
        home_loccodeS.setText(home_loccode.getText());
        home_numberS.setText(home_number.getText());
        home_emailS.setText(home_email.getText());
        home_streetS.setText(home_street.getText());
        home_postalcodeS.setText(home_postalcode.getText());
        home_cityS.setText(home_city.getText());
        
        business_departmentS.setVisible(departmentToggle.isSelected());
        business_prefixS.setVisible(prefixToggle.isSelected());
        business_givenS.setVisible(givenToggle.isSelected());
        business_familyS.setVisible(familyToggle.isSelected());
        if (business_familyS.isVisible()&&!business_givenS.isVisible()) {
            business_givenS.setText(""); business_givenS.setVisible(true);
        }
        
        home_prefixS.setVisible(prefixToggle.isSelected());
        home_givenS.setVisible(givenToggle.isSelected());
        home_familyS.setVisible(familyToggle.isSelected());
        if (home_familyS.isVisible()&&!home_givenS.isVisible()) {
            home_givenS.setText(""); home_givenS.setVisible(true);
        }
        
        
        home_slashS.setVisible(home_telephoneToggle.isSelected());
        home_emailS.setVisible(home_emailToggle.isSelected());
        home_streetS.setVisible(home_streetToggle.isSelected());
        home_postS.setVisible(home_cityToggle.isSelected());
        home_telS.setVisible(home_telephoneToggle.isSelected());
        home_eS.setVisible(home_emailToggle.isSelected());
        home_downS.setVisible(home_cityToggle.isSelected()||home_streetToggle.isSelected());
        
        business_slashS.setVisible(business_telephoneToggle.isSelected());
        business_emailS.setVisible(business_emailToggle.isSelected());
        business_streetS.setVisible(business_streetToggle.isSelected());
        business_postS.setVisible(business_cityToggle.isSelected());
        business_telS.setVisible(business_telephoneToggle.isSelected());
        business_eS.setVisible(business_emailToggle.isSelected());
        business_upS.setVisible(departmentToggle.isSelected());
        business_logoS.setVisible(departmentToggle.isSelected());
        business_downS.setVisible(business_cityToggle.isSelected()||business_streetToggle.isSelected());
    }
    
    private void initToolTips(){
        String onToolTip = java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("greenArrowToolTipText");
        String offToolTip = java.util.ResourceBundle.getBundle("cebit/proxy/gui/language").getString("stopSignToolTipText");
        
        if(prefixToggle.isSelected()){prefixToggle.setToolTipText(onToolTip);}else{prefixToggle.setToolTipText(offToolTip);};
        if(departmentToggle.isSelected()){departmentToggle.setToolTipText(onToolTip);}else{departmentToggle.setToolTipText(offToolTip);};
        if(givenToggle.isSelected()){givenToggle.setToolTipText(onToolTip);}else{givenToggle.setToolTipText(offToolTip);};
        if(familyToggle.isSelected()){familyToggle.setToolTipText(onToolTip);}else{familyToggle.setToolTipText(offToolTip);};
        if(home_telephoneToggle.isSelected()){home_telephoneToggle.setToolTipText(onToolTip);}else{home_telephoneToggle.setToolTipText(offToolTip);};
        if(home_emailToggle.isSelected()){home_emailToggle.setToolTipText(onToolTip);}else{home_emailToggle.setToolTipText(offToolTip);};
        if(home_streetToggle.isSelected()){home_streetToggle.setToolTipText(onToolTip);}else{home_streetToggle.setToolTipText(offToolTip);};
        if(home_cityToggle.isSelected()){home_cityToggle.setToolTipText(onToolTip);}else{home_cityToggle.setToolTipText(offToolTip);};
        if(business_telephoneToggle.isSelected()){business_telephoneToggle.setToolTipText(onToolTip);}else{business_telephoneToggle.setToolTipText(offToolTip);};
        if(business_emailToggle.isSelected()){business_emailToggle.setToolTipText(onToolTip);}else{business_emailToggle.setToolTipText(offToolTip);};
        if(business_streetToggle.isSelected()){business_streetToggle.setToolTipText(onToolTip);}else{business_streetToggle.setToolTipText(offToolTip);};
        if(business_cityToggle.isSelected()){business_cityToggle.setToolTipText(onToolTip);}else{business_cityToggle.setToolTipText(offToolTip);};
    }
    
    /** Testhmethode. Mglicherweise veraltet. */
    public static void main(String[] args) {
        javax.swing.JFrame f = new javax.swing.JFrame();
        VisitenKarte k = new VisitenKarte();
        java.util.Properties p = new java.util.Properties();
        p.setProperty("#user.department","DuD");
        p.setProperty("#user.name.prefix","Dipl.-Inf.");
        p.setProperty("#user.name.given","Thomas");
        p.setProperty("#user.name.family","Kriegelstein");
        p.setProperty("#user.home-info.telecom.telephone.loccode","0351");
        p.setProperty("#user.home-info.telecom.telephone.number","4701XXX");
        p.setProperty("#user.business-info.telecom.telephone.loccode","0351");
        p.setProperty("#user.business-info.telecom.telephone.number","46338XXX");
        p.setProperty("#user.home-info.online.email","tk4@inf.tu-dresden.de");
        p.setProperty("#user.business-info.online.email","drim@inf.tu-dresden.de");
        p.setProperty("#user.home-info.postal.street","Hildexxxxxstrae X");
        p.setProperty("#user.business-info.postal.street","Hans-Grundig-Strae 25");
        p.setProperty("#user.home-info.postal.postalcode","01XXX");
        p.setProperty("#user.business-info.postal.postalcode","01307");
        p.setProperty("#user.home-info.postal.city","Dresden");
        p.setProperty("#user.business-info.postal.city","Dresden");
        k.set(p);
        f.getContentPane().add(k);
        f.pack();
        f.show();
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField business_city;
    private javax.swing.JLabel business_cityS;
    private javax.swing.JToggleButton business_cityToggle;
    private javax.swing.JLabel business_departmentS;
    private javax.swing.JSeparator business_downS;
    private javax.swing.JLabel business_eS;
    private javax.swing.JTextField business_email;
    private javax.swing.JLabel business_emailS;
    private javax.swing.JToggleButton business_emailToggle;
    private javax.swing.JLabel business_familyS;
    private javax.swing.JLabel business_givenS;
    private javax.swing.JTextField business_loccode;
    private javax.swing.JLabel business_loccodeS;
    private javax.swing.JLabel business_logoS;
    private javax.swing.JTextField business_number;
    private javax.swing.JLabel business_numberS;
    private javax.swing.JPanel business_postS;
    private javax.swing.JTextField business_postalcode;
    private javax.swing.JLabel business_postalcodeS;
    private javax.swing.JLabel business_prefixS;
    private javax.swing.JPanel business_slashS;
    private javax.swing.JTextField business_street;
    private javax.swing.JLabel business_streetS;
    private javax.swing.JToggleButton business_streetToggle;
    private javax.swing.JLabel business_telS;
    private javax.swing.JToggleButton business_telephoneToggle;
    private javax.swing.JSeparator business_upS;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JTextField department;
    private javax.swing.JToggleButton departmentToggle;
    private javax.swing.JTextField family;
    private javax.swing.JToggleButton familyToggle;
    private javax.swing.JTextField given;
    private javax.swing.JToggleButton givenToggle;
    private javax.swing.JTextField home_city;
    private javax.swing.JLabel home_cityS;
    private javax.swing.JToggleButton home_cityToggle;
    private javax.swing.JSeparator home_downS;
    private javax.swing.JLabel home_eS;
    private javax.swing.JTextField home_email;
    private javax.swing.JLabel home_emailS;
    private javax.swing.JToggleButton home_emailToggle;
    private javax.swing.JLabel home_familyS;
    private javax.swing.JLabel home_givenS;
    private javax.swing.JTextField home_loccode;
    private javax.swing.JLabel home_loccodeS;
    private javax.swing.JTextField home_number;
    private javax.swing.JLabel home_numberS;
    private javax.swing.JPanel home_postS;
    private javax.swing.JTextField home_postalcode;
    private javax.swing.JLabel home_postalcodeS;
    private javax.swing.JLabel home_prefixS;
    private javax.swing.JPanel home_slashS;
    private javax.swing.JTextField home_street;
    private javax.swing.JLabel home_streetS;
    private javax.swing.JToggleButton home_streetToggle;
    private javax.swing.JLabel home_telS;
    private javax.swing.JToggleButton home_telephoneToggle;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextPane jTextPane2;
    private javax.swing.JToggleButton lockButton;
    private javax.swing.JComboBox prefix;
    private javax.swing.JToggleButton prefixToggle;
    // End of variables declaration//GEN-END:variables
    
    /** Debugflag. */
    public static final boolean debug = false;
}
