package cebit.proxy.idm;

import java.util.Properties;

import org.w3c.tools.resources.*;
import org.w3c.jigsaw.html.*;
import org.w3c.jigsaw.http.*;
import org.w3c.www.http.*;
import org.w3c.jigsaw.frames.HTTPFrame;
import org.w3c.jigsaw.auth.AuthFilter;
import org.w3c.jigsaw.proxy.*;
import org.w3c.www.mime.MimeType;

import idman.dbi.Database;
import cebit.proxy.Proxy;

public class RoleFrame extends HTTPFrame {

	public static boolean debug = true;

	/**
	 * Generate some Response.
	 * @param request The request to handle.
	 * @return A Reply instance.
	 * @exception ProtocolException if processing the request failed
	 * @exception NotAProtocolException if an internal error occurs
	 */
	protected Reply getOtherResource(Request request)
		throws ProtocolException {
		HtmlGenerator g = new HtmlGenerator("SSONET - IDMAN - Rolle");
		HtmlLink styleLink =
			new HtmlLink("STYLESHEET", "idm/style.css", MimeType.TEXT_CSS);
		g.addLink(styleLink);
		g.append(
			"<table align=\"center\" border=\"0\"><tr><td class=\"role\">");
		g.append(
			"<h3>",
			(String) request.getState(AuthFilter.STATE_AUTHUSER),
			"</h3>");
		g.append(
			"<img src=\"idm/",
			(String) request.getState(AuthFilter.STATE_AUTHUSER),
			".png\">");
		g.append("</td></tr></table><br clear=\"all\">");
		// Link to logging servlet
		// find out role id
		psman.data.Role role = null;
		try {
			psman.dbi.DBI dbi = null;
			FramedResource fr = request.getClient().getServer().getRoot();
			if (fr == null) {
				System.out.println("ERR: Root frame not found.");
			} else {
				String rid = fr.getIdentifier();
				if (debug)
					System.out.println("INF: Root is: " + fr.getIdentifier());
				if (!rid.equals("proxy")) {
					System.out.println("Root is not proxy. Error.");
				} else {
					if (debug)
						System.out.println("INF: Root is called proxy.");
					ProxyFrame idm = null;
					idm =
						(ProxyFrame) fr.getFrame(
							"cebit.proxy.idm.IDMProxyFrame");
					if (idm instanceof cebit.proxy.idm.IDMProxyFrame) {
						Properties settings = Proxy.idManager.settings;
						try {
							dbi = Database.getDBI(settings);
						} catch (Exception e) {
							System.out.println(
								"Exception while getting the DBI. Error.");
						}
					}
				}
			}
			role =
				dbi.selectRole(
					(String) request.getState(AuthFilter.STATE_AUTHUSER));
		} catch (Exception e) {
			if (debug)
				e.printStackTrace();
		}
		g.append(
			"<a href=\"/servlet/LoggingServlet"
				+ (role == null ? "" : ("?selectedRole=" + role.getID()))
				+ "&lang="
				+ java.util.Locale.getDefault().toString()
				+ "\" target=\"_blank\">"
				+ java.util.ResourceBundle.getBundle(
					"cebit/proxy/gui/language").getString(
					"LOGGING_PSERSONAL_DATA_TRANSACTIONS_PARTNERS")
				+ "</a>");
		Reply reply = createDefaultReply(request, HTTP.OK);
		reply.setStream(g);
		return reply;
	}

	/**
	 * register our associated resource as an "other" resource.
	 */
	public void registerResource(FramedResource resource) {
		super.registerOtherResource(resource);
	}
}
