package cebit.proxy.idm;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.w3c.tools.resources.*;
import org.w3c.jigsaw.http.*;

public class SetupServlet extends HttpServlet {
    
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        
        ServletConfig   cfg = getServletConfig();
        ServletContext  ctx = cfg.getServletContext();
        ServerInterface inf = null;
        // Out Println is used to as comments...
        out.println("<html><head><title>SetupServlet</title></head><body>");
        out.println("Diagnostics:<br><pre>");
        
        if (ctx instanceof org.w3c.jigsaw.servlet.JigsawServletContext) {
            inf = ((org.w3c.jigsaw.servlet.JigsawServletContext)ctx).getServer();
            out.println("INF: Server is: "+inf.getClass().toString());
            boolean b = inf instanceof httpd;
            out.println("INF: Server is httpd compliant: "+b);
            
            FramedResource fr = inf.getRoot();
            if (fr==null) {
                out.println("ERR: Root not found.");
            } else {
                String rid = fr.getIdentifier();
                out.println("INF: Root is: "+fr.getIdentifier());
                FramedResource proxy = null;
                FramedResource role = null;
                if (rid.equals("proxy")) {
                    out.println("INF: Root is called proxy.");
                } else {
                    // root->DirectoryResource
                    if (fr instanceof DirectoryResource) {
                        Hashtable pdefs = new Hashtable(3);
                        proxy = new FramedResource();
                        Hashtable rdefs = new Hashtable(3);
                        role = new FramedResource();
                        try {
                            ((DirectoryResource)fr).registerResource("role", role, rdefs);
                            ((DirectoryResource)fr).registerResource("proxy", proxy, pdefs);
                            inf.checkpoint();
                            if (b) {
                                Properties p = ((httpd)inf).getProperties();
                                Resource r = ((httpd)inf).getPropertySet("general");
                                if (r!=null) {
                                    r.setValue(httpd.ROOT_NAME_P, "proxy");
                                    ((httpd)inf).propertyChanged(httpd.ROOT_NAME_P);
                                } else {
                                    out.println("ERR: r was null.");
                                }
                                out.println("INF: props: "+p.getProperty(httpd.ROOT_NAME_P));
                            } else {
                                out.println("ERR: root anchnaged, server incompatible.");
                            }
                            fr = inf.getRoot();
                            out.println("ACT: Changed root to: "+fr.getIdentifier());
                        } catch (InvalidResourceException ire) {
                            out.println("ERR: Change failed. Exception occured.");
                            out.println(ire);
                            fr = null;
                        }
                    } else {
                        out.println("ERR: Unknown root. Can't proceed.");
                        out.println("INF: Rootclass: "+fr.getClass().toString());
                        fr = null;
                    }
                }
                
                // register the role frame within JigSaw
                RoleFrame rf = null;
                if (role!=null) {
                    Hashtable defs = new Hashtable(3);
                    defs.put("identifier", "role-0");
                    rf = (RoleFrame)fr.getFrame("cebit.proxy.idm.RoleFrame");
                    if (rf==null) {
                        rf = new RoleFrame();
                        role.registerFrame(rf, defs);
                        out.println("ACT: Registered RoleFrame.");
                    } else {
                        out.println("INF: Skipped RoleFrame.");
                    }
                } else {
                    out.println("INF: Skipped RoleFrame for nonexistend resource.");
                }
                
                // register the IDMProxyFrame within JigSaw
                IDMProxyFrame idm = null;
                if (fr!=null) {
                    Hashtable defs = new Hashtable(3);
                    defs.put("identifier", "proxy-0");
                    defs.put("local-root", "root");
                    idm = (IDMProxyFrame)fr.getFrame("cebit.proxy.idm.IDMProxyFrame");
                    if (idm==null) {
                        idm = new IDMProxyFrame();
                        fr.registerFrame(idm, defs);
                        out.println("ACT: Registered IDMProxyFrame.");
                    } else {
                        out.println("INF: Skipped IDMProxyFrame for nonexistend resource.");
                    }
                }
                
                // register IDMAuthFilter within Jigsaw
                IDMAuthFilter idmaf = null;
                if (idm!=null) {
                    Hashtable defs = new Hashtable(6);
                    defs.put("identifier", "auth-0");
                    idmaf = (IDMAuthFilter)idm.getFrame("cebit.proxy.idm.IDMAuthFilter");
                    
                    if (idmaf==null) {
                        idmaf = new IDMAuthFilter();
                        idm.registerFrame(idmaf, defs);
                        out.println("ACT: Registered Authorisation for ProxyFrame.");
                    } else {
                        out.println("INF: Skipped Authorisation for ProxyFrame.");
                    }
                } else {
                    out.println("INF: Skipped Authorisation for nonexistend ProxyFrame.");
                }
                out.println("INF: Root is now: "+fr.getIdentifier());
            }
        } else {
            out.println("! Error !");
            out.println("");
            out.println("Not running within Jigsaw. Servlet failed. Do not try again.");
        }
        out.println("</pre><hr>The IDMAN Team</body></html>");
    }
}
