package cebit.server.idm;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import idman.mngt.*;

public class ShopServlet extends HttpServlet {

	public void doGet(HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException {
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		if (debug) {
			System.out.println("QueryString: " + request.getQueryString());
			//System.out.println("URLPath:     "+request.getURLPath());
			//System.out.println("URL:         "+request.getURL());
		}

		// find out language (default is german, other language is given in QueryString with "lang=XXX"
		String lang = "de";
		if (request.getQueryString() != null) {
			int langIdx = request.getQueryString().lastIndexOf("lang=");
			if (langIdx >= 0) {
				String s = request.getQueryString().substring(langIdx + 5);
				langIdx = s.indexOf("&");
				if (langIdx >= 0) {
					s = s.substring(0, langIdx);
				}
				if (!s.equals("")) {
					lang = s;
				}
			}
		}
		if (debug)
			System.out.println("ShopFrame: Language: " + lang);

		Locale locale = Locale.GERMAN;
		if (lang.equals("en"))
			locale = Locale.ENGLISH;
		if (debug)
			System.out.println("ShopFrame: Language: " + locale.getLanguage());

		// generate top of the page
		String page = "";
		page
			+= getFileContent(
				getFile(
					java.util.ResourceBundle.getBundle(
						"cebit/server/idm/locale",
						locale).getString(
						"TOP")));
		page
			+= getFileContent(
				getFile(
					java.util.ResourceBundle.getBundle(
						"cebit/server/idm/locale",
						locale).getString(
						"MENU")));
		page
			+= "<td background=\"../webshop/mitte_bg.png\" class=\"content\">\n";

		Object o = request.getAttribute("org.ssonet.context");
		if (o != null && o instanceof idman.mngt.Context) {
			Context context = (Context) o; // Context besorgen
			if (debug)
				msg();
			if (debug)
				out("getOtherResource: getManagement()");
			Management idManager = context.getManagement();
			if (debug)
				msg();

			// check, if enoungh data has arrived
			// we need: user.name.given
			//          user.name.family
			//    eighter:   user.home-info.postal.street
			//               user.home-info.postal.postalcode
			//               user.home-info.postal.city
			//    or:        user.department
			//               user.business-info.postal.street
			//               user.business-info.postal.postalcode
			//               user.business-info.postal.city

			boolean purchaseCompleted = true;

			//is the goodsNumber valid
			int goodIndex = -1;
			String q = request.getQueryString();
			if (debug)
				System.out.println("ShopFrame: QueryString:" + q);
			if (q != null && q.length() > 0) {
				int idx = q.indexOf("article=");
				if (idx >= 0) {
					q = q.substring(idx + 8);
					if (debug)
						System.out.println(
							"ShopFrame: String after removing article=:" + q);
					idx = q.indexOf("&");
					if (idx >= 0) {
						q = q.substring(0, idx);
					}
					try {
						if (debug)
							System.out.println(
								"ShopFrame: String (only the number):" + q);
						goodIndex = Integer.parseInt(q);
					} catch (Exception e) {
						if (debug)
							System.err.println(
								"ShopFrame: GoodIndex="
									+ q
									+ ". This is an invalid number.");
					}
				}
				if (goodIndex < 0 || goodIndex > goodsCount) {
					if (debug)
						System.err.println("ShopFrame: Invalid goodIndex.");
					purchaseCompleted = false;
					page += "<div class=\"error\">";
					page
						+= java.util.ResourceBundle.getBundle(
							"cebit/server/idm/locale",
							locale).getString(
							"ORDER_ERROR");
					page += "</div>";
				} else {
					//look, if such data is allready available
					Hashtable buyerData = new Hashtable();
					if (!getBuyerData(buyerData, idManager, context)) {
						if (!requestBuyerData(buyerData, idManager, context)) {
							purchaseCompleted = false;
							page
								+= java.util.ResourceBundle.getBundle(
									"cebit/server/idm/locale",
									locale).getString(
									"NEED_ADDRESS");
							page += "<br>\n";
							Enumeration e = buyerData.keys();
							if (e.hasMoreElements()) {
								page
									+= java.util.ResourceBundle.getBundle(
										"cebit/server/idm/locale",
										locale).getString(
										"HAVE_FOLLOWING_DATA");
								page += "<br><br>\n";
								for (int i = 0; i < pdOrder.length; i++) {
									String pdItem =
										(String) buyerData.get(pdOrder[i]);
									if (pdItem != null) {
										page
											+= java.util.ResourceBundle.getBundle(
												"cebit/server/idm/locale",
												locale).getString(
												pdOrder[i].substring(1))
											+ ": "
											+ buyerData.get(pdOrder[i])
											+ "<br>\n";
									}
								}
							} else {
								page
									+= java.util.ResourceBundle.getBundle(
										"cebit/server/idm/locale",
										locale).getString(
										"GOT_NO_DATA_FROM_YOU");
								page += "<br><br>\n";
							}
							page
								+= java.util.ResourceBundle.getBundle(
									"cebit/server/idm/locale",
									locale).getString(
									"PLEASE_CONFIGURE_YOUR_IDM")
								+ "<br>\n"
								+ java.util.ResourceBundle.getBundle(
									"cebit/server/idm/locale",
									locale).getString(
									"SO_THAT_WE_GET_ACCESS_TO_YOUR_ADDRESS_DATA")
								+ "<br><br>\n";
						}
					}
					if (purchaseCompleted) {
						page
							+= "<center><table border=\"0\" width=\"90%\" background=\"menu_bg.png\">\n"
							+ "<tr><td align=\"center\"><h3>"
							+ java.util.ResourceBundle.getBundle(
								"cebit/server/idm/locale",
								locale).getString(
								"THANKS_FOR_BUYING")
							+ "</h3></td></tr></table></center><br><br>";
						page
							+= java.util.ResourceBundle.getBundle(
								"cebit/server/idm/locale",
								locale).getString(
								"ARTICLE_BOUGHT")
							+ "<b> "
							+ java.util.ResourceBundle.getBundle(
								"cebit/server/idm/locale",
								locale).getString(
								"ARTICLE_" + Integer.toString(goodIndex))
							+ "</b><br><br>";
						page
							+= java.util.ResourceBundle.getBundle(
								"cebit/server/idm/locale",
								locale).getString(
								"ARTICLE_IS_DELIVERED_TO_FOLLOWING_ADDRESS")
							+ "<br>";
						page
							+= "<table width=\"70%\" border=\"0\" bgcolor=\"white\"><tr><td>\n";
						if ((buyerData.get("#user.business-info.postal.city")
							== null)
							|| (((String) buyerData
								.get("#user.business-info.postal.city"))
								.equals(""))) {
							// Show home data
							page += buyerData.get("#user.name.given")
								+ " "
								+ buyerData.get("#user.name.family")
								+ "<br>\n";
							page
								+= buyerData.get("#user.home-info.postal.street")
								+ "<br>\n";
							page
								+= buyerData.get(
									"#user.home-info.postal.postalcode")
								+ " "
								+ buyerData.get("#user.home-info.postal.city")
								+ "<br>\n";
						} else {
							// Show business data
							page += buyerData.get("#user.department")
								+ "<br>\n";
							page += buyerData.get("#user.name.given")
								+ " "
								+ buyerData.get("#user.name.family")
								+ "<br>\n";
							page
								+= buyerData.get(
									"#user.business-info.postal.street")
								+ "<br>\n";
							page
								+= buyerData.get(
									"#user.business-info.postal.postalcode")
								+ " "
								+ buyerData.get(
									"#user.business-info.postal.city")
								+ "<br>\n";
						}
						page += "</td></tr></table><br>";
					}
				}
			} else {
				page += "<div class=\"error\">";
				page
					+= java.util.ResourceBundle.getBundle(
						"cebit/server/idm/locale",
						locale).getString(
						"PLEASE_COOSE_AN_ARTICLE_FIRST");
				page += "</div>";
			}

		} else {
			page += "<b>"
				+ java.util.ResourceBundle.getBundle(
					"cebit/server/idm/locale",
					locale).getString(
					"NO_IDM_USED")
				+ "</b><br>";
			page += "<b>"
				+ java.util.ResourceBundle.getBundle(
					"cebit/server/idm/locale",
					locale).getString(
					"DRIM_SHOP_ONLY_USABLE_WITH_IDM")
				+ "</b><br>";
		}
		page += "<br><br>";
		page += "<center><table border=\"0\" background=\"menu_bg.png\"><tr>"
			+ "<td><a href=\"../webshop/"
			+ java.util.ResourceBundle.getBundle(
				"cebit/server/idm/locale",
				locale).getString(
				"SHOP")
			+ "\">"
			+ java.util.ResourceBundle.getBundle(
				"cebit/server/idm/locale",
				locale).getString(
				"BACK_TO_THE_SHOP")
			+ "</a></td></tr></table></center></td>\n";

		//generate bottom of the page
		page
			+= getFileContent(
				getFile(
					java.util.ResourceBundle.getBundle(
						"cebit/server/idm/locale",
						locale).getString(
						"BOTTOM")));
		out.println(page);
	}
	public static boolean debug = false;

	public static final int goodsCount = 20;

	public String[] pdOrder =
		{
			"#user.department",
			"#user.name.prefix",
			"#user.name.given",
			"#user.name.family",
			"#user.home-info.telecom.telephone.loccode",
			"#user.home-info.telecom.telephone.number",
			"#user.home-info.online.email",
			"#user.home-info.postal.street",
			"#user.home-info.postal.postalcode",
			"#user.home-info.postal.city",
			"#user.business-info.telecom.telephone.loccode",
			"#user.business-info.telecom.telephone.number",
			"#user.business-info.online.email",
			"#user.business-info.postal.street",
			"#user.business-info.postal.postalcode",
			"#user.business-info.postal.city" };

	private String s;
	private long t;
	private void out(String s) {
		this.s = s;
		this.t = System.currentTimeMillis();
		System.out.println(s);
	}
	private void msg() {
		this.t = System.currentTimeMillis() - t;
		System.out.println(s + ": " + t);
	}

	/**
	 * This method gets user supplied data from the database.
	 * 
	 * @param  buyerData here the data is to be stored
	 * @return true, if enough buyerData was received, false otherwise
	 */
	private boolean getBuyerData(
		Hashtable buyerData,
		Management manager,
		Context context) {
		byte[][] dataField;
		for (int i = 0; i < pdOrder.length; i++) {
			dataField = manager.getReceivedData(pdOrder[i], context);
			if (dataField.length > 0)
				buyerData.put(pdOrder[i], new String(dataField[0]));
			else
				; // System.out.println("INF: No data for: "+pdOrder[i]);
		}
		return receivedEnoughData(buyerData);
	}

	/**
	 * This method tries to fetch data form the user, which was not allready received.
	 * 
	 * @param  buyerData here the data is to by stored
	 * @return true, if enough buyerData was received, false otherwise
	 */
	private boolean requestBuyerData(
		Hashtable buyerData,
		Management manager,
		Context context) {
		String[] privateData =
			new String[] {
				"#user.name.given",
				"#user.name.family",
				"#user.home-info.postal.street",
				"#user.home-info.postal.postalcode",
				"#user.home-info.postal.city" };
		String[] recipient = { "ours" };
		String[] purpose = { "current" };
		String retention = "indefinitely";
		if (manager
			.requestData(privateData, recipient, purpose, retention, context)) {
			for (int i = 0; i < privateData.length; i++) {
				String id = privateData[i];
				byte[][] data = manager.getReceivedData(id, context);
				if (data != null && data.length > 0)
					buyerData.put(id, new String(data[0]));
			}
		}
		if (receivedEnoughData(buyerData))
			return true;
		String[] businessData =
			new String[] {
				"#user.name.given",
				"#user.name.family",
				"#user.department",
				"#user.business-info.postal.street",
				"#user.business-info.postal.postalcode",
				"#user.business-info.postal.city" };
		if (manager
			.requestData(
				businessData,
				recipient,
				purpose,
				retention,
				context)) {
			for (int i = 0; i < businessData.length; i++) {
				String id = businessData[i];
				byte[][] data = manager.getReceivedData(id, context);
				if (data != null && data.length > 0)
					buyerData.put(id, new String(data[0]));
			}
		}
		return receivedEnoughData(buyerData);
	}

	private boolean receivedEnoughData(Hashtable buyerData) {
		if (buyerData.get("#user.name.given") == null
			|| buyerData.get("#user.name.given").equals(""))
			return false;
		if (buyerData.get("#user.name.family") == null
			|| buyerData.get("#user.name.family").equals(""))
			return false;
		// NOT (A||B) wenn A bzw B Fehler sind -> KEINER DER FEHLER TRITT AUF
		if (!(buyerData.get("#user.home-info.postal.street") == null
			|| buyerData.get("#user.home-info.postal.street").equals("")
			|| buyerData.get("#user.home-info.postal.postalcode") == null
			|| buyerData.get("#user.home-info.postal.postalcode").equals("")
			|| buyerData.get("#user.home-info.postal.city") == null
			|| buyerData.get("#user.home-info.postal.city").equals("")))
			return true;
		if (!(buyerData.get("#user.department") == null
			|| buyerData.get("#user.department").equals("")
			|| buyerData.get("#user.business-info.postal.street") == null
			|| buyerData.get("#user.business-info.postal.street").equals("")
			|| buyerData.get("#user.business-info.postal.postalcode") == null
			|| buyerData.get("#user.business-info.postal.postalcode").equals("")
			|| buyerData.get("#user.business-info.postal.city") == null
			|| buyerData.get("#user.business-info.postal.city").equals("")))
			return true;
		return false;
	}
	/**
	 * @param  name the name of the file to get.
	 * @return a File for a given name, which is in the same directory as this Frame
	 */
	private synchronized File getFile(String name) {
		return new File(new File("."), "server/Jigsaw/WWW/webshop/" + name);
	}

	/**
	 * Reads the content of a File into a String.
	 * 
	 * @param  f the File to read
	 * @return the content of the file, or an empty string if the file was not found.
	 */
	private String getFileContent(File f) {
		String s = "";
		try {
			FileInputStream fis = new FileInputStream(f);
			int c;
			do {
				c = fis.read();
				if (c >= 0)
					s += new String(new byte[] {(byte) c });
			} while (c >= 0);
			return s;
		} catch (Exception e) {
			if (debug)
				System.err.println(
					"File "
						+ (f == null ? "!!!null!!!" : f.getName())
						+ " not found!");
			return "";
		}
	}
}
