package cebit.server.idm;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import idman.mngt.*;

/**
 * <p>Title: The ShowDataServlet</p>
 * <p>Description: This servlet shows the user his personal data which the server has stored. He can change or delete it</p>
 * @author Nancy Worch
 * @version $Id: ShowDataServlet.java,v 1.3 2003/12/05 14:37:45 sc2 Exp $
 */

public class ShowDataServlet extends HttpServlet {

	public static boolean debug = true;

	private Locale locale;
	
	/**
	 * Performs the request
	 * @return the HTML-Page for the given request.
	 */    
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    	throws IOException, ServletException 
    {
        response.setContentType("text/html");

        // Einen PrintWriter auf die Antwort aufsetzen
        PrintWriter out = response.getWriter();

        // find out language (default is german, other language is given in QueryString with "lang=XXX"
        String lang = "de";
        if(request.getQueryString() != null){
            int langIdx = request.getQueryString().lastIndexOf("lang=");
            if(langIdx >=0){
                String s = request.getQueryString().substring(langIdx+5);
                langIdx = s.indexOf("&");
                if(langIdx >=0){
                    s = s.substring(0, langIdx);
                }
                if(!s.equals("")){
                    lang=s;
                }
            }
        }

        locale = Locale.GERMAN;
        if(lang.equals("en"))locale = Locale.ENGLISH;
        if(debug)System.out.println("ShopFrame: Language: "+locale.getLanguage());

        // generate top of the page
        String page = "";
        page += getFileContent(getFile(java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale).getString("TOP")));
        page += getFileContent(getFile(java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale).getString("MENU")));
        page += "<td background=\"../webshop/mitte_bg.png\" class=\"content\">\n";

        page += "<table border=\"0\"><tr><td><img src=\"../webshop/idmlogo.gif\" border=\"0\" alt=\"\"></td>\n";
        page += "<td><h2>DRIM-Shop personal Data</h2></td></tr></table>";

        // generate the site

        Object o = request.getAttribute("org.ssonet.context");
        if (o!=null && o instanceof idman.mngt.Context) {

        	Context context = (Context)o; // Context besorgen

	     	page +="<h3>"
     			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
     			.getString("PSERONAL_DATA_TRANSMISSION")
    			 +"</h3>";
     		page +=("<FORM ACTION=\"" + request.getRequestURI () + "\" method=GET>");

     		// Eine Auflistung aller Parameternamen aus der Anfrage holen
     		Enumeration parameterNamen = request.getParameterNames();
			// Anweisung ausfhren
     		changeDatabase(parameterNamen, context, request);
     		
     		// Daten anzeigen
     		psman.data.DataField[] receivedData = {};
     		psman.data.TPartner tpartner = context.getTPartner();

     		try {
				psman.dbi.DBI db = idman.dbi.Database.getDBI(context);
				receivedData = db.selectDataField(tpartner);
				if(debug)System.out.println(receivedData.length+" data fields found.");
				java.util.Set set1 = new java.util.HashSet();
				java.util.Date now = new java.util.Date();
				for (int i=0; i<receivedData.length; i++) {
					if (receivedData[i].getValidFrom().before(now) &&
						(receivedData[i].getValidUntil().getTime()==0 ||
						receivedData[i].getValidUntil().after(now))) {
							set1.add(receivedData[i]);
					}
				}
				receivedData = (psman.data.DataField[])set1.toArray(new psman.data.DataField[set1.size()]);
				if(debug)System.out.println(receivedData.length+" data fields remain after check.");

           		if (receivedData.length>0) {
             		page += "<p>"
             			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
             			.getString("AENDERN_ERLEUTERUNG")+"</p>\n";
             		page += "<p>"
             			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
             			.getString("LOESCHEN_ERLEUTERUNG")+"</p>\n";
             		page +="<b>"
             			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
             			.getString("SERVER_HAS_FOLLOWING_DATA_FROM_YOU")+"</b>\n";
             		page +="<table width=\"70%\" border=\"0\" bgcolor=\"white\">\n";
             		for(int i = 0; i<SecInfoServlet.pdOrder.length; i++){
                 		for(int c=0; c<receivedData.length; c++) {
                     		if(receivedData[c].getName().equals(SecInfoServlet.pdOrder[i])){
                         		page +="<tr><td class=\"secgoalhead\" background=\"menu_bg.png\">"
                         			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
                         			.getString(receivedData[c].getName().substring(1))+"</td>\n";
                         		page +="<td class=\"secgoalother\" background=\"mitte_bg.png\">"
                         			+new String(receivedData[c].getValue())+"</td>\n";
								page +="<td><input type=\"radio\" name=\""+SecInfoServlet.pdOrder[i]+"\" value=\"" 
									+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
									.getString("KORREKT")+ "\" checked></td><td>" 
									+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
									.getString("KORREKT")+ "</td>\n";
								page +="<td><input type=\"radio\" name=\""+SecInfoServlet.pdOrder[i]+"\" value=\"" 
									+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
									.getString("AENDERN")+ "\"></td><td>" 
									+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
									.getString("AENDERN")+ "</td>\n";
								page +="<td><input type=\"radio\" name=\""+SecInfoServlet.pdOrder[i]+"\" value=\"" 
									+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
									.getString("LOESCHEN")+ "\"></td><td>" 
									+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
									.getString("LOESCHEN")+ "</td>\n";
                      		}
                 		}
             		}
             		page +="</table>";

             		if(lang.equals(("en"))) {
                		page += "<INPUT TYPE=\"hidden\" NAME=\"lang\" VALUE=\"en\">";
             		}

             		page +="\n<INPUT TYPE=SUBMIT VALUE=\"OK\">\t";
             		page +="<Input type=\"reset\">";
         		} else {
             		page += "<b>"
             			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
             			.getString("SERVER_RECEIVED_NO_DATA")
             			+"</b><br><br>";
         		}
     		} catch (Exception e) {
         		page +="<i>"
         			+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale)
         			.getString("ERROR_WHILE_ACCESSING_DATABASE")
         			+e.toString()+")</i>";
     		}
     		page +="\n";
     		page +="</FORM>";
 		} else {
        page +="<b>"
        	+java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale).getString("NO_IDM_USED")
            +"</b><br>";
    	}
    	//generate bottom of the page
    	page += getFileContent(getFile(java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale).getString("BOTTOM")));
    	out.println(page);
	}

    /**
     * @param name the name of the file to get.
     * @return a File for a given name, which is in the same directory as this Frame
     */
    private synchronized File getFile(String name) {
        return new File(new File("."), "server/Jigsaw/WWW/webshop/"+name);
    }

    /**
     * Reads the content of a File into a String.
     * @param f the File to read
     * @return the content of the file, or an empty string if the file was not found.
     */
    private String getFileContent(File f){
        String s = "";
        try{
            FileInputStream fis = new FileInputStream(f);
            int c;
            do{
                c = fis.read();
                if(c >= 0) s += new String(new byte[] {(byte)c});
            }while(c >= 0);
            return s;
        }catch(Exception e){
            if(debug)System.err.println("File "+(f==null?"!!!null!!!":f.getName())+" not found!");
            return "";
        }
    }

    /**
     * This method takes the changes which the user made in the servlet before and 
     * changes the database. If the enumeration value is "delete" it writes 
     * *geloescht* in the Value of the datafield. If the enumerationvalue is 
     * "change" it initiate the transmission of the correct date from the identity 
     * manager of the user. In both cases it sets the validUntil date of the 
     * datafield to the actual date.
     * @param enumeration the Values the user has selected
     * @param contextServlet is the context os the servlet
     * @param requestServlet is the request of the servlet
     */
    private void changeDatabase(Enumeration enumeration, Context contextServlet,
    	HttpServletRequest requestServlet) 
    {
   		Enumeration parameterNamen = enumeration;
        Context context = contextServlet;
        HttpServletRequest request = requestServlet;

        psman.data.DataField[] receivedData = {};
        psman.data.TPartner tpartner = context.getTPartner();

        try {
          	psman.dbi.DBI db2 = idman.dbi.Database.getDBI(context);
            receivedData = db2.selectDataField(tpartner);

            String oldName = ""; // Zwischenspeicher, um berfluessige Durchlufe zu vermeiden

            // while there are elements in the enumeration
            while (parameterNamen.hasMoreElements()) {

                // hole den nchsten Parameternamen und caste in String
                String name = (String) parameterNamen.nextElement();

                // alle Parameterwerte zum Parameternamen holen
                String[] werte = request.getParameterValues(name);

                String s1 = ("*geloescht*");
                byte[] geloescht = s1.getBytes();

                // search for enumerationvalues "delete" or "change"
                // in both cases set the validUntil date to the actuel date
                // if the enumerationvalue is "delete"
                // write *geloescht* to the Value of the datafield
                for (int i = 0; i < werte.length; i++) {
                  	if ( (werte[i].equals( (String) ("loeschen"))) ||
                        (werte[i].equals( (String) ("delete")))) 
                    {
                      	for (int n = 0; n < receivedData.length; n++) {
                        	if (receivedData[n].getName().equals(name)) {
                          		Date validUntil = new Date(); // Ungtig ab dieser Sekunde
                          		psman.data.DataField invalid 
                          			= new psman.data.DataField( // Datenfeld mit den g\u00FCltigen Eintr\u00E4gen
                              			receivedData[n].getID(), // damit der richtige Eintrag gefunden wird
                              			receivedData[n].getOwner(), // beibehalten
                              			receivedData[n].getName(), // beibehalten
                              			geloescht, // loeschen des Wertes
                              			receivedData[n].getValidFrom(), // beibehalten
                              			validUntil); // gendert!
                          		db2.update(invalid); // Eintrag berschreiben
                          		//jetzt wre es gut, wenn man den Wert noch mit dem 
                          		// oeffentlichen Schluessel verschluesseln wrde
                        	}
                      	}
                    }

                    // if the enumerationvalue is "change"
                    // initiate the transmission of the correct value from the user
                    if ( (werte[i].equals( (String) ("aendern"))) ||
                        werte[i].equals( (String) ("change"))) 
                    {
                      	for (int n = 0; n < receivedData.length; n++) {
                        	if (receivedData[n].getName().equals(name)) {
                          		Date validUntil = new Date(); // Ungltig ab dieser Sekunde
                          		psman.data.DataField invalid = new psman.data.DataField( // Datenfeld mit den g\u00FCltigen Eintr\u00E4gen
                              		receivedData[n].getID(), // damit der richtige Eintrag gefunden wird
                              		receivedData[n].getOwner(), // beibehalten
                              		receivedData[n].getName(), // beibehalten
                              		receivedData[n].getValue(), // beibehalten
                              		receivedData[n].getValidFrom(), // beibehalten
                              		validUntil); // gendert!
                          		db2.update(invalid); // Eintrag berschreiben
                        	}
                      	}

                      	for (int m = 0; m < receivedData.length; m++) {
                        	if (receivedData[m].getName().equals(name) &&
                            	(!receivedData[m].getName().equals(oldName))) 
                            {

                           		// try to fetch data from the user, which shall be changed
                           		// data is fetched with following constraints:
                           		// recipient: "ours"
                           		// purpose: "current"
                           		// retention: "stated-purpose"
                           		oldName = name;
                           		String ids[] = new String[] {receivedData[m].getName()};
                           		String recipient[] = new String[]{"ours"};
                           		String purpose[] = new String[]{"current"};
                           		String retention = "stated-purpose";
                           		boolean gotData = context.getManagement().requestData(
									ids, recipient, purpose, retention, contextServlet);
								if(debug){
									if(!gotData)System.out.println("Could not fetch data, which was to be corrected.");
								}
                        	}
                      	}
                    }
                }
            } //Ende while

            oldName = "";
        }catch (Exception e) {
        	System.err.println("ERROR_WHILE_ACCESSING_DATABASE");
/*            page += "<i>"
                  +java.util.ResourceBundle.getBundle("cebit/server/idm/locale", locale).
                  getString("ERROR_WHILE_ACCESSING_DATABASE")
                  + e.toString() + ")</i>";
  */    }

    }
}
